--=============================================================================
-- File:		DKP_Data.lua
-- Author:	(synd][cate) 
--          Sammysnake of Ner'Zhul	 2004, 2005 Syndicate Systems
--
-- Version: 0.10
--
-- Description:	Centralized data for DKP_System & DKP_Matrix Addons
--
-- Created: May 15, 2006 
-- Modified: May 15, 2006 
--=============================================================================

-- Declard color codes for console messages
local RED     = "|cffff0000";
local GREEN   = "|cff00ff00";
local BLUE    = "|cff0000ff";
local MAGENTA = "|cffff00ff";
local YELLOW  = "|cffffff00";
local CYAN    = "|cff00ffff";
local WHITE   = "|cffffffff";

-- Called when DKP_Data is loaded
function DKPData_OnLoad() 
		
		-- Wait for variables to be loaded
		this:RegisterEvent("ADDON_LOADED");				
				
end

function DKPData_OnEvent( event )
		
		if ((event == "ADDON_LOADED") and (string.lower(arg1) == string.lower("dkp_data"))) then	
				
				if (DKP_DB == nil) then
						DKP_DB = {};				
				end												
				-- If there is a hard copy of the data on disk, load the data from that
				-- else, the savedvariables version will be loaded in place
				local hard_loaded = {};
				for i = 0, 4 do
						if (getglobal("dkpm_loadDB"..i) ~= nil) then
								local loaddb = getglobal("dkpm_loadDB"..i);
								loaddb();
								hard_loaded[i] = true;
						end						
				end			
				
				-- Set active database to the first database for now
				DKP_ROLL_PLAYERS = DKP_DB[0]['playerdata'];
				DKP_ROLL_RAIDS = DKP_DB[0]['raiddata'];
				DKP_ROLL_UPDATE_INFO = DKP_DB[0]['updatedata'];			
				
				-- Display which database have been loaded on startup							
				for iDB = 0, 4 do
						local str_hl = "";
						if (hard_loaded[iDB] == true) then
								str_hl = YELLOW.."(from File)";
						else
								str_hl = YELLOW.."(from SavedVars)";
						end
						if (DKP_DB[iDB] ~= nil) then
								DEFAULT_CHAT_FRAME:AddMessage(GREEN .. "DKP_Data -- Database ["..iDB.."]: Loaded :: ".. DKP_DB[iDB]['dbname'] .." "..str_hl);
						else
								DEFAULT_CHAT_FRAME:AddMessage(RED .. "DKP_Data -- Database ["..iDB.."]: Not Loaded");
						end
				end				
				
				-- 	
				if (DKP_DB[0] == nil) then
						DEFAULT_CHAT_FRAME:AddMessage(RED .. "DKP_Matrix ".. YELLOW ..":: Warning: DKP_Data could not be loaded, please run the DKP_ updater!");
						DEFAULT_CHAT_FRAME:AddMessage(RED .. "DKP_Matrix ".. YELLOW ..":: Warning: (1) Please ensure that there is a database listed in slot [0]");
						DEFAULT_CHAT_FRAME:AddMessage(RED .. "DKP_Matrix ".. YELLOW ..":: Warning: (2) Ignore this message if you planning on using the sync function instead of the updater.");
				end
		end

end