
--Local Function Prototypes
local CheckUserExists, Send_Whisper, Display_BOT_Usage, Display_RaidPoints, Display_TopRaidPoints;
local element_exists;

local Pre_ChatFrame_OnEvent;
				

function DKPMB_OnLoad ()

    -- respond to bot whispers
    this:RegisterEvent("CHAT_MSG_WHISPER");
    this:RegisterEvent("CHAT_MSG_WHISPER_INFORM");

		if (CheckUserExists("alex")) then
				DEFAULT_CHAT_FRAME:AddMessage("User FOUND!!!");
		end
		
		-- Setup whisper hook
		Pre_ChatFrame_OnEvent = ChatFrame_OnEvent;
		ChatFrame_OnEvent = DKPMB_ChatFrame_OnEvent;

end

function DKPMB_ChatFrame_OnEvent(event)

		-- If the DKP_Roll bot is disabled, just return control back to normal hook
		if (DKPMB_Options.BotEnabled ~= 1) then				
				return Pre_ChatFrame_OnEvent(event);
		end
	
		if ( (event == "CHAT_MSG_WHISPER_INFORM") 		
	 	 and (DKPMB_Options.HideOutgoingTells == 1) 	
		 and (string.find( arg1, "^"..DKPMB_Options.WhisperPrefix)) ) then		-- Is a bot outgoing whisper				
				-- Hide whisper
		elseif ( (event == "CHAT_MSG_WHISPER") 		
	 	 and (DKPMB_Options.HideIncomingTells == 1) 	
		 and (string.find( arg1, "^"..DKPMB_Options.BotATT)) ) then		-- Is a bot incoming whisper				
		 		-- Hide whisper
		else
				return Pre_ChatFrame_OnEvent(event);
		end
		
end

function DKPMB_OnEvent( event )		
		
		local pattern_eng = "(.+) rolls (%d+)";
		local pattern_ger = "(.+) wrfelt. Ergebnis: (%d+)";
		
		local roll_name, roll_num;		
		local use_roll_name, use_roll_num;
		
		local message = arg1;
		local s, e;
		local raid_points, raid_roll;
		local numArgs, result;
		
		local itemName, itemCost;
		local upperName;
		
		local isValidBotUser = false;
		
		local bot_attention = DKPMB_Options.BotATT;				
		
		if (event == "CHAT_MSG_WHISPER") then
				
				if (DKPMB_Options.BotEnabled ~= 1) then						
						if (arg1 ~= (DKPMB_Options.WhisperPrefix .. DKPM_BOT_DISABLED)) then
								Send_Whisper(arg2, DKPM_BOT_DISABLED);
						end
						return;
				end
				
				-- Check if there is a database available for the bot
				local dbavail = false;
				for iDB = 0, 4 do
						if (DKP_DB[iDB] ~= nil) then
								dbavail = true;								
						end
				end	
				if (dbavail == false) then
						-- No databases available
						Send_Whisper(arg2, DKPM_BOT_NOAVAILDB);
						return;
				end
				
		
		-----------------------------------------------------------------------------
		-- BOT ARGUMENTS
		-----------------------------------------------------------------------------				
				
				-- Split up arguments with " " as the delimiter.
						
				args = GetArgs(arg1, " ");
				arg2 = string.lower(arg2);
				
				-- Get the number of arguments
				numArgs = table.getn(args);
				
				if ((not CheckUserExists(arg2)) and (DKPMB_Options.LimitAccess == 1)) then
						-- If player is not found in any of our databases, access denied
						isValidBotUser = false;			
									
				else 
						isValidBotUser = true;
				end
				
				if ((isValidBotUser) and (args[1] == bot_attention)) then
						-- Set default settings if this is the first time the user has used the bot				
						-- Check to see if ANY user search prefrences exist, if not declare them
						if (DKPMB_Options.BOT_Options == nil) then
								DKPMB_Options.BOT_Options = {};
						end
						
						-- Check to see if specific search preferences exist, if not declare them
						if (DKPMB_Options.BOT_Options[arg2] == nil) then
								DKPMB_Options.BOT_Options[arg2] = {};
						end
						
						local new_user = false;
						-- Check to see if searchmode option is set
						if (DKPMB_Options.BOT_Options[arg2]['searchmode'] == nil) then
								Send_Whisper(arg2, format(DKPM_BOT_NEWUSER1, bot_attention));
								DKPMB_Options.BOT_Options[arg2]['searchmode'] = "all";
								new_user = true;
						end
						
						-- Check to see if search threshold is set
					 	if (DKPMB_Options.BOT_Options[arg2]['search_threshold'] == nil) then
					 			Send_Whisper(arg2, format(DKPM_BOT_NEWUSER2, bot_attention));
					 			DKPMB_Options.BOT_Options[arg2]['search_threshold'] = 0;
					 			new_user = true;
					 	end						
						
						-- Check to see if search results is set
					 	if (DKPMB_Options.BOT_Options[arg2]['search_results'] == nil) then
					 			Send_Whisper(arg2, format(DKPM_BOT_NEWUSER3, bot_attention));
					 			DKPMB_Options.BOT_Options[arg2]['search_results'] = 10;
					 			new_user = true;
					 	end						
					 	
					 	if (DKPMB_Options.BOT_Options[arg2]['activedb']	== nil) then
			 					if (DKP_DB[0] ~= nil) then
			 							DKPMB_Options.BOT_Options[arg2]['activedb'] = 0;
			 							Send_Whisper(arg2, format(DKPM_BOT_NEWUSER4, bot_attention));
			 					else
			 							Send_Whisper(arg2, DKPM_BOT_FATALERR_CANNOTINI);	
			 							return;
			 					end
						end
		
						-- Since we have a few tew user settings, let the user know they can get help on the command
						if (new_user) then
								Send_Whisper(arg2, format(DKPM_BOT_NEWUSER5, bot_attention, bot_attention));
								Send_Whisper(arg2, DKPM_BOT_NEWUSER6);
						end
				elseif ((not isValidBotUser) and (args[1] == bot_attention)) then
						-- Player is not in our database, but wants to use the bot
						Send_Whisper(arg2, DKPM_BOT_ACCESSDENIED);
						return;
				else						
						-- Player may or may not be valid, but is not using an rp command so ignore it			
						return; 
				end
				
				
				-- Shorten a few often used options				
				local activeDB = DKPMB_Options.BOT_Options[arg2]['activedb'];
				
				-------------------------------------------------------------------------
				-- BOT:SEARCH COMMAND
				-------------------------------------------------------------------------
				-- Checks for arguments of 3 or more, for search queries				
				
				if ((numArgs >= 3) and (args[1] == bot_attention) and (args[2] == "search")) then																
						
						local i;
						local KeyWords = {};
						
						-- Get a table of the keywords we want to look for!
						for i=3, numArgs, 1 do
								--DEFAULT_CHAT_FRAME:AddMessage(i .. ":".. args[1]);
								table.insert(KeyWords, args[i]);
						end
						
						--DEFAULT_CHAT_FRAME:AddMessage(RED .. "DKP_System: " .. WHITE .. "Preforming a search...");
						
						local SearchMode = DKPMB_Options.BOT_Options[arg2]['searchmode'];
						local SearchThreshold = DKPMB_Options.BOT_Options[arg2]['search_threshold'];
						local DisplayResults = DKPMB_Options.BOT_Options[arg2]['search_results'];

						Display_ItemSearchResults(arg2, KeyWords, SearchMode, SearchThreshold, DisplayResults);
						
				elseif (numArgs == 1) then
						---------------------------------------------------
						-- BOT : Commands that use 1 arguments
						---------------------------------------------------												
						if (args[1] == bot_attention) then								
								---------------------------------------------------
								-- BOT : Player wants to check their own raidpoints
								---------------------------------------------------
								
								Display_RaidPoints(arg2, arg2);
								
						end -- End of (1) argument commands
				-- Check if command is for DKP, for 2 argument only
				elseif (numArgs == 2) then
						---------------------------------------------------
						-- BOT : Commands that use 2 arguments
						---------------------------------------------------												
					
						if ((string.lower(args[1]) == bot_attention) and (args[2] == "top")) then
								---------------------------------------------------
								-- BOT : (2 args) Display Top 5 user's raidpoints
								---------------------------------------------------
						
								-- Display Top 5 user's raidpoints
								Display_TopRaidPoints(arg2, 10);	
						
						elseif ((args[1] == bot_attention) and ((args[2] == "help") or 
						(args[2] == "?") or	(args[2] == "commands"))) then
								---------------------------------------------------
								-- BOT : (2 args) Display help
								---------------------------------------------------						
						
								Display_BOT_Usage(arg2);
						
						elseif ((args[1] == bot_attention) and
						(args[2] == "items")) then
								---------------------------------------------------
								-- BOT : (2 args) Display users item History
								---------------------------------------------------						
						
								Display_ItemHistory(arg2);

						elseif ((args[1] == bot_attention) and
						(args[2] == "graids")) then								
								---------------------------------------------------
								-- BOT : (2 args) Display guilds raid History
								---------------------------------------------------							
							
								Display_GuildRaidResults(arg2, nil);
						
						elseif ((args[1] == bot_attention) and
						(args[2] == "raids")) then
								---------------------------------------------------
								-- BOT : (2 args) Displays bot users raid History
								---------------------------------------------------										
								
								Display_GuildRaidResults(arg2, arg2);
						
						
						elseif ((args[1] == bot_attention) and
						(args[2] == "stats")) then
								---------------------------------------------------
								-- BOT : (2 args) Display Database Statistics
								---------------------------------------------------							
						
								Display_Database_Stats(arg2);
						elseif ((args[1] == bot_attention) and
						(args[2] == "listdb")) then					
								for iDB = 0, 4 do
										if (DKP_DB[iDB] ~= nil) then
												Send_Whisper(arg2, "["..iDB.."] ".. DKP_DB[iDB]['dbname']);
										end
								end	
								Send_Whisper(arg2, format(DKPM_BOT_ERR_INVALIDBSELECT2,bot_attention));		
							
						elseif (args[1] == bot_attention) then
								---------------------------------------------------
								-- BOT : (2 args) Display rp's for a specified user (arg2)
								---------------------------------------------------																															
								
								Display_RaidPoints(args[2], arg2);	
								
						end -- End of (2) argument commands
				-- Check if command is for DKP, for 3 argument only
				elseif (numArgs == 3) then

						---------------------------------------------------
						-- BOT : Commands that use 3 arguments
						---------------------------------------------------		
					
						if ((args[1] == bot_attention) and (args[2] == "selectdb")) then
								---------------------------------------------------
								-- BOT : (3 args) Select active database (for multidatabase support)
								---------------------------------------------------							
								local iSelectdb = tonumber(args[3]);
								if (DKP_DB[iSelectdb] ~= nil) then
										DKPMB_Options.BOT_Options[arg2]['activedb'] = iSelectdb;
										Send_Whisper(arg2, "Database ["..iSelectdb.."]".. DKP_DB[iSelectdb]['dbname'] .." selected!");				
								else
										Send_Whisper(arg2, DKPM_BOT_ERR_INVALIDBSELECT1);										
										for iDB = 0, 4 do
												if (DKP_DB[iDB] ~= nil) then
														Send_Whisper(arg2, "["..iDB.."] ".. DKP_DB[iDB]['dbname']);
												end
										end			
										Send_Whisper(arg2, format(DKPM_BOT_ERR_INVALIDBSELECT2,bot_attention));																		
								end
				
						elseif ((args[1] == bot_attention) and (args[2] == "top") 
						   and (element_exists(DKPM_Class, args[3]))) then
								---------------------------------------------------
								-- BOT : (3 args) Display top raidpoints for <#results> users
								---------------------------------------------------										
								Display_TopRaidPoints(arg2, DKPMB_Options.BOT_Options[arg2]['search_results'], args[3]);
						
						elseif ((args[1] == bot_attention) and (args[2] == "top") 
						and (tonumber(args[3]) == nil)) then
												
								-- If user types "rp top <string>" display error
								-- since string should be a number....
								Send_Whisper(arg2, DKPM_ERROR_USAGE);
								Display_BOT_Usage(arg2);	
								return;					
														
						elseif ((args[1] == bot_attention) and (args[2] == "items")) then
								---------------------------------------------------
								-- BOT : (3 args) Display someone elses items
								---------------------------------------------------										
														
								Display_ItemHistory(arg2, args[3]);								
								return;
								
						elseif ((args[1] == bot_attention) and (args[2] == "raids")) then
								---------------------------------------------------
								-- BOT : (2 args) Displays bot users raid History
								---------------------------------------------------										
								
								Display_GuildRaidResults(arg2, args[3]);						
						
						elseif((args[1] == bot_attention) and (args[2] == "raidinfo")) then
						
								if (tonumber(args[3]) ~= nil) then
										Display_RaidStats(arg2, args[3]);
								else
										Send_Whisper(arg2, format(DKPM_BOT_ERR_MISMATCH_RAIDINFO, bot_attention));
								end
							
						elseif ( (args[1] == bot_attention) and (args[2] == "searchmode") 
						and ((args[3] == "all") or (args[3] == "any")) ) then
								---------------------------------------------------
								-- BOT : (3 args) SETTINGS: Change search mode
								---------------------------------------------------										
								
								if (args[3] == "all") then
										-- Set matching mode to all words
																																								
										DKPMB_Options.BOT_Options[arg2]['searchmode'] = "all";
										Send_Whisper(arg2, format(DKPM_BOT_SEARCH_MODE, "ALL"));
										
										--DEFAULT_CHAT_FRAME:AddMessage(RED .. "DKP_System: ".. WHITE .. "Searching Mode for ".. arg2 ..", set to all words.");
										
								elseif (args[3] == "any") then
										-- Set matching mode to any words										
										
										-- See if Bot Options exist										
										if (DKPMB_Options.BOT_Options == nil) then
												DKPMB_Options.BOT_Options = {};
										end										
										
										-- See if settings for this user exist
										if (DKPMB_Options.BOT_Options[arg2] == nil) then
												DKPMB_Options.BOT_Options[arg2] = {};
										end
										
										DKPMB_Options.BOT_Options[arg2]['searchmode'] = "any";
										Send_Whisper(arg2, format(DKPM_BOT_SEARCH_MODE, "ANY"));
										
										--DEFAULT_CHAT_FRAME:AddMessage(RED .. "DKP_Roll: ".. WHITE .. "Searching Mode for ".. arg2 ..", set to any words.");
								else
										-- shouldn't happen
								end
						elseif ( (args[1] == bot_attention) and (args[2] == "searchth") 
						and (tonumber(args[3]) ~= nil)  ) then
								---------------------------------------------------
								-- BOT : (3 args) SETTINGS: Chance search threshold
								---------------------------------------------------								
								-- eg. only search for items over a specific DKP value
																
								DKPMB_Options.BOT_Options[arg2]['search_threshold'] = tonumber(args[3]);
								Send_Whisper(arg2, format(DKPM_BOT_SEARCH_THRESHOLD, args[3]));

						elseif ( (args[1] == bot_attention) and (args[2] == "results") 
						and (tonumber(args[3]) ~= nil)  ) then
								---------------------------------------------------
								-- BOT : (3 args) SETTINGS: Chance number of results to return for each query
								---------------------------------------------------			
								
								DKPMB_Options.BOT_Options[arg2]['search_results'] = tonumber(args[3]);
								Send_Whisper(arg2, format(DKPM_BOT_SEARCH_RESULTS, args[3]));
								
						elseif ( (args[1] == bot_attention) and (args[2] == "help") ) then

								---------------------------------------------------
								-- BOT : (3 args) HELP: Displays help for a certain command
								---------------------------------------------------			
								
								Send_Whisper(arg2, "Displaying help for the command ".. string.upper(args[3]));
								
								if (args[3] == "top") then
										-- Display help for 'rp help top'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_TOP_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_TOP_USAGE_LINE2,bot_attention));
								elseif (args[3] == "items") then
										-- Display help for 'rp help items'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_ITEMS_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_ITEMS_USAGE_LINE2,bot_attention));
								elseif (args[3] == "search") then
										-- Display help for 'rp help search'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_SEARCH_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_SEARCH_USAGE_LINE2,bot_attention,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_SEARCH_USAGE_LINE3,bot_attention));
								elseif (args[3] == "searchmode") then
										-- Display help for 'rp help searchmode'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_SEARCHMODE_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, DKPM_BOT_HELP_SEARCHMODE_USAGE_LINE2);
										Send_Whisper(arg2, DKPM_BOT_HELP_SEARCHMODE_USAGE_LINE3);
								elseif (args[3] == "searchth") then
										-- Display help for 'rp help searchth'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_SEARCHTH_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, DKPM_BOT_HELP_SEARCHTH_USAGE_LINE2);
								elseif (args[3] == "graids") then
										-- Display help for 'rp help graids'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_GRAIDS_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_GRAIDS_USAGE_LINE2,bot_attention));
								elseif (args[3] == "raidinfo") then
										-- Display help for 'rp help raidinfo'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_RAIDINFO_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_RAIDINFO_USAGE_LINE2,bot_attention));
								elseif (args[3] == "raids") then
										-- Display help for 'rp help raids'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_RAIDS_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_RAIDS_USAGE_LINE2,bot_attention));
								elseif (args[3] == "listdb") then
										-- Display help for 'rp help listdb'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_LISTDB_USAGE_LINE1,bot_attention));
										Send_Whisper(arg2, format(DKPM_BOT_HELP_LISTDB_USAGE_LINE2));
								elseif (args[3] == "selectdb") then
										-- Display help for 'rp help dbselect'
										Send_Whisper(arg2, format(DKPM_BOT_HELP_SELECTDB_USAGE_LINE1,bot_attention,bot_attention));
								else
										-- Invalid command given to find help on
										Send_Whisper(arg2, DKPM_ERROR_HELP_USAGE);
										Display_BOT_Usage(arg2);
								end
								
								
						elseif (args[1] == bot_attention) then
								
								-- Unrecognized Command
								Send_Whisper(arg2, DKPM_ERROR_USAGE);
								Display_BOT_Usage(arg2);
						else 
								-- Not an rp command
						end
				end												
		end				
		
end

function CheckUserExists( username ) 
		
		username = string.lower(username);
				
		-- Display which database have been loaded on startup							
		for iDB = 0, 4 do
				if (DKP_DB[iDB] ~= nil) then
						if (DKP_DB[iDB]['playerdata'][username] ~= nil) then
								return true;
						end
				end
		end
		
		return false;
end

function Send_Whisper(playerName, Message) 		
		local whisper_prefix = DKPMB_Options.WhisperPrefix;
		return SendChatMessage(whisper_prefix .. " " .. Message, "WHISPER", this.language, playerName);
end

function Display_BOT_Usage (playerName)
		local bot_attention = DKPMB_Options.BotATT;
		
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE1, bot_attention));
		Send_Whisper(playerName, DKPM_BOT_COMMAND_USAGE_LINE2);
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE3, bot_attention, bot_attention));
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE4, bot_attention, bot_attention, bot_attention));
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE5, bot_attention, bot_attention));
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE6, bot_attention));
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE7, bot_attention, bot_attention));
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE8, bot_attention, bot_attention));
		Send_Whisper(playerName, format(DKPM_BOT_COMMAND_USAGE_LINE9, bot_attention, bot_attention));		
end


function Display_RaidPoints ( player, msgplayer ) 
		local activeDB = DKPMB_Options.BOT_Options[arg2]['activedb'];		
		if (DKP_DB[activeDB]['playerdata'][player] ~= nil) then
				local userdata = DKP_DB[activeDB]['playerdata'][player];
				local pointsSpent = 0;
				local pointsGained = 0;
				
				if (userdata ~= nil ) then
						for itemName, itemData in userdata['Items'] do
								pointsSpent = pointsSpent + itemData['cost'];
						end
				else
						pointsSpent	= 0;
				end
				
				pointsGained = userdata['RaidPoints'] + pointsSpent;
		
				Send_Whisper(msgplayer, format(DKPM_BOT_USERDKP_DETAILED, userdata['RaidPoints'], pointsSpent, pointsGained));
				Send_Whisper(msgplayer, format(DKPM_BOT_LAST_DB_UPDATE, date("%b %d, %y %H:%M:%S ", DKP_DB[activeDB]['dbdate'])));
		else
				-- DKP_ROLL_PLAYERS[player] is empty, therefore no record exists for that player.
				Send_Whisper(msgplayer, format(DKPM_ERROR_PLAYER_NOT_FOUND,player));
		end	
end

--[[
--	Display_TopRaidPoints(arg1, arg2, arg3);
--	
--	description:
--		- Displays 
--
--	args: 
--		- arg1	: [string] playername
--		- arg2	: [string] number of results to display
--		- arg3  : [string] what class to display
--
--	returns:
--		- nil
--]]

function Display_TopRaidPoints(arg1, NumResults, arg3)
		local playerName, playerArray, playerKey, playerValue, playerPoints, playerRank;
		local PlayerNames = {};		
		local PlayerRaidPoints = {};
		
		local playerNameUpper;
		local a,b,n1,n2;
		
		local activeDB = DKPMB_Options.BOT_Options[arg2]['activedb'];
		--DKP_DB[activeDB]['playerdata'][player];
		
		for playerName, playerArray in DKP_DB[activeDB]['playerdata'] do																		
				PlayerRaidPoints[playerName] = playerArray['RaidPoints'];
				table.insert(PlayerNames, playerName);							
		end			
		
		table.sort(PlayerNames, function (n1, n2)
        return PlayerRaidPoints[n1] > PlayerRaidPoints[n2]    -- compare the grades
    end)
            
    if (arg3 ~= nil) then
    		playerNameUpper = string.upper(arg3);  
    		Send_Whisper(arg1, format(DKPM_BOT_QUERY_TOPDKP_FOR, NumResults, playerNameUpper));
    else 
    		Send_Whisper(arg1, format(DKPM_BOT_QUERY_TOPDKP_OVERALL, NumResults));
    end
    
    a = 1;
		for playerRank, playerName in PlayerNames do
			playerNameUpper = string.upper(playerName);
			
			--DEFAULT_CHAT_FRAME:AddMessage("#"..playerRank .. " " .. playerNameUpper .. " with " .. PlayerRaidPoints[playerName] .. " raidpoints.");
			if (a <= NumResults) then
					if (arg3 ~= nil) then
							-- Top DKP of specific Class
							if (string.lower(arg3) == string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class'])) then
									Send_Whisper(arg1, format(DKPM_BOT_QUERY_DKP, a, playerNameUpper, PlayerRaidPoints[playerName], playerRank));
									a = a + 1;
							elseif (string.lower(arg3) == DKPM_Class['cloth']) then
									if ( 	(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.priest) or 
												(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.mage) or
												(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.warlock) ) then
											Send_Whisper(arg1, format(DKPM_BOT_QUERY_DKP_CLASS, playerRank, DKP_DB[activeDB]['playerdata'][playerName]['Class'], playerNameUpper, PlayerRaidPoints[playerName]));
											a = a + 1;							
									end
							elseif (string.lower(arg3) == DKPM_Class['leather']) then
									if ( 	(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.druid) or 
												(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.rogue) ) then
											Send_Whisper(arg1, format(DKPM_BOT_QUERY_DKP_CLASS, playerRank, DKP_DB[activeDB]['playerdata'][playerName]['Class'], playerNameUpper, PlayerRaidPoints[playerName]));
											a = a + 1;							
									end
							elseif (string.lower(arg3) == DKPM_Class['mail']) then
									if ( 	(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.shaman) or 
												(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.hunter) ) then
											Send_Whisper(arg1, format(DKPM_BOT_QUERY_DKP_CLASS, playerRank, DKP_DB[activeDB]['playerdata'][playerName]['Class'], playerNameUpper, PlayerRaidPoints[playerName]));
											a = a + 1;							
									end		
							elseif (string.lower(arg3) == DKPM_Class['plate']) then
									if ( 	(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.warrior) or 
												(string.lower(DKP_DB[activeDB]['playerdata'][playerName]['Class']) == DKPM_Class.paladin) ) then
											Send_Whisper(arg1, format(DKPM_BOT_QUERY_DKP_CLASS, playerRank, DKP_DB[activeDB]['playerdata'][playerName]['Class'], playerNameUpper, PlayerRaidPoints[playerName]));
											a = a + 1;							
									end																										
							end
					else
							-- Top DKP
							Send_Whisper(arg1, format(DKPM_BOT_QUERY_DKP_CLASS, playerRank, DKP_DB[activeDB]['playerdata'][playerName]['Class'], playerNameUpper, PlayerRaidPoints[playerName]));
							a = a + 1;
					end
			end 			
		end

end

--[[
--	Display_ItemHistory(arg1, arg2, arg3);
--	
--	description:
--		- Displays 
--
--	args: 
--		- arg1	: [string] playername
--		- arg2	: [string] number of results to display
--		- arg3  : [string] what class to display
--
--	returns:
--		- nil
--]]

function Display_ItemHistory(playerName, playerLookup, arg3)
		local playerArray, playerKey, playerValue, playerPoints, playerRank;
		local ItemNames = {};		
		local ItemArray = {};
		local ItemRank, PlayerToLookup;						
		
		local itemName, itemCost;
		local totalRaidPoints = 0;
		
		local activeDB = DKPMB_Options.BOT_Options[arg2]['activedb'];
		
		if (playerLookup ~= nil) then				
				PlayerToLookup = string.lower(playerLookup);
		else				
				PlayerToLookup = string.lower(playerName);
		end
		
		
		if (DKP_DB[activeDB]['playerdata'][PlayerToLookup] == nil) then 
				-- Check to see if player exists in array
				PlayerToLookup = string.upper(PlayerToLookup);
				Send_Whisper(playerName, format(DKPM_BOT_ITEM_NOHISTORY, PlayerToLookup));
				return;
		elseif (DKP_DB[activeDB]['playerdata'][PlayerToLookup]['Items'] == nil) then
				-- Check to see if player's items exists in array
				PlayerToLookup = string.upper(PlayerToLookup);
				Send_Whisper(playerName, format(DKPM_BOT_ITEM_NOHISTORY, PlayerToLookup));
				return;				
		else				
				-- Do nothin
		end
		
		for itemName, itemData in DKP_DB[activeDB]['playerdata'][PlayerToLookup]['Items'] do
				ItemArray[itemName] = itemData['cost'];
				table.insert(ItemNames, itemName);
		end				
		
		table.sort(ItemNames, function (n1, n2)
        return ItemArray[n1] > ItemArray[n2]    -- compare the grades
    end)
		
		PlayerToLookup = string.upper(PlayerToLookup);
		Send_Whisper(playerName, format(DKPM_BOT_ITEM_HISTORY,  PlayerToLookup));
		for itemRank, itemName in ItemNames do				
				Send_Whisper(playerName, ItemArray[itemName].." DKP] ".. DKPM_GetItemLinkText(itemName));
				totalRaidPoints = totalRaidPoints + ItemArray[itemName];
		end
		Send_Whisper(playerName, format(DKPM_BOT_ITEM_DKPSPENT, totalRaidPoints));
end

--[[
--	Display_ItemSearchResults(msgName, KeyWords, SearchMode, SearchThreshold, SearchLimit);
--	
--	description:
--		- Displays an Item search given specific keywords to search for, two different modes..
--      If RequireMode is true, all keywords are required for a search to return a result,
--			where as if false returns all items which match any of they keywords.
--
--	args: 
--		- arg1	: [string] msgName - Name of the player to message with the results
--		- arg2	: [array] KeyWords - A table of keywords to search for
--		- arg3  : [string] SearchMode - 'any' or 'all' of the words needs to match
--		- arg4  : [number] SearchThreshold - Searches for items with dkp higher than this number
--
--	returns:
--		- nil
--]]


function Display_ItemSearchResults(msgName, KeyWords, SearchMode, SearchThreshold, SearchLimit)
		
		local activeDB = DKPMB_Options.BOT_Options[arg2]['activedb'];
		local bot_attention = DKPMB_Options.BotATT;
		
		local playerName, playerAttrib, playerNameUpper;
		local itemName, itemCost, itemNameUpper;
		
		local AttribName;
		local AttribValue;
		
		local index, currentKeyWord;
		local returnResult, foundResult;
		
		local results = 0;
				
		--DEFAULT_CHAT_FRAME:AddMessage("Keywords:".. KeyWords);
		
		Send_Whisper(msgName, "Searching... (mode='".. SearchMode.."' threshold<=".. SearchThreshold .." results=".. SearchLimit ..")");
		
		for playerName, playerAttrib in DKP_DB[activeDB]['playerdata'] do				
			  if (playerAttrib['Items'] ~= nil) then
				for itemName, itemData in playerAttrib['Items'] do										
						
						-- Result Variables
						returnResult = true;
						foundResult = false;
						
						for index, currentKeyWord in KeyWords do		
						
								--DEFAULT_CHAT_FRAME:AddMessage("Current KeyWord:".. currentKeyWord);
								
								if ((string.find( string.lower(itemName), currentKeyWord)) 
								and (itemData['cost'] >= SearchThreshold)) then
											-- Item found matching keyword, send results to user									
											
											playerNameUpper = string.upper(playerName);				
											itemNameUpper = string.upper(itemName);
											
											-- If we are doing an 'any' search we have a result.
											foundResult = true;															
								else
										-- If we are doing an 'all' search, it just failed.
										returnResult = false;
								end								
								
						end
						
						if (returnResult 
						and (SearchMode == "all")) then
								
								-- Only display limited number of results
								if (results < SearchLimit) then
										Send_Whisper(msgName, itemData['cost'] .." DKP] ".. DKPM_GetItemLinkText(itemName) .." found on ".. playerNameUpper );
								end												
								results = results +1;																																						
						elseif (foundResult 
						and (SearchMode == "any")) then
								-- Only display limited number of results
								if (results < SearchLimit) then
										Send_Whisper(msgName, itemData['cost'] .." DKP] ".. DKPM_GetItemLinkText(itemName) .." found on ".. playerNameUpper );
								end
								results = results +1;
						else
								-- None of the keywords matched
						end										
				end								
				end
				
				--if (playerAttrib == "Items") then						
				--		for itemName, itemCost in DKP_ROLL_PLAYERS[playerName]['Items'] do						
				--				DEFAULT_CHAT_FRAME:AddMessage(playerName ..":".. itemName);
				--		end						
				--end
		
		end
				
		if (results < SearchLimit) then
				SearchLimit = results;
		end
		
		-- Display how many results were found!!
		Send_Whisper(msgName, "Displaying ".. SearchLimit .." of ".. results .." matching items.");
		Send_Whisper(msgName, "Type '".. bot_attention .." results <number>' to change the number of results displayed!");
		
end

--[[
--	Display_GuildRaidResults(msgName);
--	
--	description:
--		- Displays lastest raids encountered by the guild
--
--	args: 
--		- arg1	: [string] msgName - Name of the player to message with the results
--
--	returns:
--		- nil
--]]

function Display_GuildRaidResults(msgName, playerName) 

		local activeDB = DKPMB_Options.BOT_Options[arg2]['activedb'];
		local bot_attention = DKPMB_Options.BotATT;

		local n1,n2;
		local SortedRaids = {};
		local RaidTimeStamps = {};
		local CountResults = 0;
		local NumResults = DKPMB_Options.BOT_Options[arg2]['search_results'];
		local attendPlayer, attendPlayerClass;
		local attendCount = 0;
		local totalRaids = 0;
		
		local raid_id, raid_name, raid_worth, raid_date;
		
		if (playerName == nil) then
				Send_Whisper(msgName, "Displaying last ".. NumResults .." guild raids..");
		else
				Send_Whisper(msgName, "Displaying last ".. NumResults .." raids for ".. string.upper(playerName));
		end
		
		for raidTimeStamp, raidAttribute in DKP_DB[activeDB]['raiddata'] do										
				table.insert(SortedRaids, raidTimeStamp);
		end				

		table.sort(SortedRaids, function(a,b) return a>b end)    
    
    Send_Whisper(msgName, "[ ID ] __Information__");
		for raidRank, raidTimeStamp in SortedRaids do
				raid_id = DKP_DB[activeDB]['raiddata'][raidTimeStamp]['raid_id'];				
				raid_name = DKP_DB[activeDB]['raiddata'][raidTimeStamp]['raid_name'];				
				raid_worth = DKP_DB[activeDB]['raiddata'][raidTimeStamp]['raid_worth'];
				raid_date = DKP_DB[activeDB]['raiddata'][raidTimeStamp]['raid_date'];
				
				if ((playerName == nil) and (CountResults < NumResults)) then
						-- Display guild raids
						Send_Whisper(msgName, "[ ".. raid_id .." ] "..raid_name .."  DKP=".. raid_worth .."  ".. raid_date);
						CountResults = CountResults+1;
				else
						-- Display raids for a certain player
						for index, attendPlayer in DKP_DB[activeDB]['raiddata'][raidTimeStamp]['raid_attendees'] do
								if (attendPlayer == playerName) then
										if (CountResults < NumResults) then
												Send_Whisper(msgName, "[ ".. raid_id .." ] "..raid_name .."  DKP=".. raid_worth .."  ".. raid_date);
												CountResults = CountResults+1;
										end										
										attendCount = attendCount+1;
								end
						end
				end		
				
				totalRaids = totalRaids+1;
		end
		
		if (CountResults == 0) then
				Send_Whisper(msgName, "No attended events for ".. string.upper(playerName) .." found in last ".. totalRaids .." raids!");
		else
				if (playerName ~= nil) then						
						Send_Whisper(msgName, string.upper(playerName) .." attended the last ".. attendCount .." of ".. totalRaids .." raid events.");
				else
						Send_Whisper(msgName, "Finished displaying ".. CountResults .." results of ".. totalRaids .." raid events.");
				end
		end
		
		Send_Whisper(msgName, "Type '".. bot_attention .." raidinfo <id>' to get more info on a specific raid.");
		Send_Whisper(msgName, "Type '".. bot_attention .." results <number>' to change the number of results returned.");
		
end

--[[
--	Display_RaidStats(msgName);
--	
--	description:
--		- Displays lastest raids encountered by the guild
--
--	args: 
--		- arg1	: [string] msgName - Name of the player to message with the results
--
--	returns:
--		- nil
--]]

function Display_RaidStats(msgName, raidID)

		local activeDB = DKPMB_Options.BOT_Options[arg2]['activedb'];
		local bot_attention = DKPMB_Options.BotATT;
		
		local useTimeStamp = 0;
		local totalAttendance = 0;
		
		local RaidTimeStamp, RaidAttribs;
		local AttribName, AttribValue;
		local className, classValues;
		
		local percent, count;

		for RaidTimeStamp, RaidAttribs in DKP_DB[activeDB]['raiddata'] do
				
				for AttribName, AttribValue in RaidAttribs do
						if ((AttribName == "raid_id") and (tonumber(AttribValue) == tonumber(raidID)) ) then
								useTimeStamp = RaidTimeStamp;						
						end
				end																
		end
		
		if (useTimeStamp ~= 0) then
				local raid_name = DKP_DB[activeDB]['raiddata'][useTimeStamp]['raid_name'];
				local raid_date = DKP_DB[activeDB]['raiddata'][useTimeStamp]['raid_date'];
				local raid_worth = DKP_DB[activeDB]['raiddata'][useTimeStamp]['raid_worth'];
				--local raid_date = DKP_ROLL_RAIDS[useTimeStamp]['raid_date'];
		
				Send_Whisper(msgName, "Raid Info for [".. raidID .."] ".. raid_name);
				Send_Whisper(msgName, "DATE: ".. raid_date .."  DKPs:".. raid_worth);				
				
				Send_Whisper(msgName, "<< Class Distribution >>");
				for className, classValues in DKP_DB[activeDB]['raiddata'][useTimeStamp]['class_distribution'] do
						for classKey, classValue in classValues do
								if (classKey == "percent") then
										percent = classValue;
								elseif (classKey == "total") then								
										count = classValue;
										totalAttendance = totalAttendance + count;
								end																
								--Send_Whisper(msgName, classKey ..":".. classValue);
						end
						Send_Whisper(msgName, "[ ".. count .." ] ".. className .." ".. percent .."%");
				end														
				Send_Whisper(msgName, totalAttendance.. " Players Total.")
				
				-- List Items Dropped
				Send_Whisper(msgName, "<< Items Dropped >>");	
				for ItemName, ItemAttribs in DKP_DB[activeDB]['raiddata'][useTimeStamp]['raid_items'] do										
				
						--Send_Whisper(msgName, ItemCost .." RP] ".. Check_Loot_Text(ItemName) .." looted by ".. string.upper(PlayerName));																		
						Send_Whisper(msgName, ItemAttribs['value'] .." DKP] ".. DKPM_GetItemLinkText(ItemName) .." looted by ".. string.upper(ItemAttribs['buyer']));																		
						
				end	
		else
				Send_Whisper(msgName, "Error: Raid ID [".. raidID .."] is invalid, type '".. bot_attention .." graids' for reference");				
		end

end

-- Check if element exists in an array

function element_exists ( array, element )

	local exists = false;
	for element_name, element_value in array do
			if (element_value == element) then
					exists = true;
			end	
	end
	
	return exists;
end