--=============================================================================
-- File:		DKP_Matrix.lua
-- Author:	(synd][cate) 
--          Sammysnake of Ner'Zhul	 2004, 2005 Syndicate Systems
--
-- Version: 0.25
--
-- Description:	Used with eqDKP now includes many DKP related utils. 
-- Now includes Open, Closed, and Roll auction systems as well as bot commands
--
-- Created: March 11, 2006 
-- Modified: August 10, 2006 
--=============================================================================

DKPM_ColumnSort = {
		['RaidHistoryList'] = "date",
		['DetailedRaidPlayerList'] = "playername",
		['DetailedRaidItemList'] = "dkp",
		['PlayerList'] = "playername_dec",
		['PlayerRaidList'] = "date",	
		['PlayerItemList'] = "dkp",
		['ItemHistoryItemList'] = "itemname_dec",
};

DKPItemCache = {};

DKPM_Options = {};
DKPM_Options.percision = "%0.0f"; 
DKPM_Options.dbselect = 1;
		
DKPM_SearchOptions = {};
DKPM_SearchOptions.IHRarity = 1;
DKPM_SearchOptions.IHArmorType = 1;
DKPM_SearchOptions.PLClass = 1;
DKPM_SearchOptions.PLArmorType = 1;

local Pre_ChatFrame_OnEvent;

-------------------------------------------
-- Local Variables                       --
-------------------------------------------

local version = "0.26";

local debug = false;

-- Declard color codes for console messages
local RED     = "|cffff0000";
local GREEN   = "|cff00ff00";
local BLUE    = "|cff0000ff";
local MAGENTA = "|cffff00ff";
local YELLOW  = "|cffffff00";
local CYAN    = "|cff00ffff";
local WHITE   = "|cffffffff";

local COLOR_POOR = "|cff9d9d9d";
local COLOR_COMMON = "|cffffffff";
local COLOR_UNCOMMON = "|cff1eff00";
local COLOR_RARE = "|cff0070dd";
local COLOR_EPIC = "|cffa335ee";
local COLOR_LEGENDARY = "|cffff8000";



DKPM_ERROR_SQLVARS_ERROR1		= RED .. "DKP_Matrix:".. WHITE .." ERROR- sqlvars.lua does not exist, please";
DKPM_ERROR_SQLVARS_ERROR2		= RED .. "DKP_Matrix:".. WHITE .." ERROR- run DKP_System Updater first.  Type";
DKPM_ERROR_SQLVARS_ERROR3		= RED .. "DKP_Matrix:".. WHITE .." ERROR- /console reloadui after you have";
DKPM_ERROR_SQLVARS_ERROR4		= RED .. "DKP_Matrix:".. WHITE .." ERROR- ran the updater and updated the variables.";
		
local DKPM_DKPColors = {	
		["positive"] = "|cff00ff00",
		["neutral"] = "|cffffff00",
		["negative"] = "|cffff0000",
}

local DKPM_ClassColors = {		
				["warlock"] = "|c009382c9",
				["warrior"] = "|c00C69B6D",	
				["shaman"] = "|c00F48CBA",
				["mage"] = "|c0068CCEF",
				["hunter"] = "|c00AAD372",
				["priest"] = "|c00FFFFFF",
				["paladin"] = "|c00F48CBA",
				["rogue"] = "|c00FFF468",
				["druid"] = "|c00FF7C0A",		
};
		
local DKPM_DropDownOptions = {
	Binds = {
			"Any",
			"Does Not",
			"On Equip",
			"On Pickup",
			"On Use" },
	Rarity = {
			{ "Any", "Any", -1 },
			{ COLOR_POOR.."Poor", "Poor", 0},
			{ COLOR_COMMON.."Common", "Common", 1},
			{ COLOR_UNCOMMON.."Uncommon", "Uncommon", 2},
			{ COLOR_RARE.."Rare", "Rare", 3},
			{ COLOR_EPIC.."Epic", "Epic", 4},
			{ COLOR_LEGENDARY.."Legendary", "Legendary", 5},
	},
	EquipTypes = {
			"Any",
			"Held In Off-hand",
			"Back",
			"One-Hand",
			"Two-Hand",
			"Off Hand",
			"Wrist",
			"Chest",
			"Legs",
			"Feet",
			"Shirt",
			"Ranged",
			"Main Hand",
			"Waist",
			"Head",
			"Gun",
			"Finger",
			"Hands",
			"Shoulder",
			"Wand",
			"Trinket",
			"Neck",
			"Thrown",
			"Crossbow"	},
			
	ArmorTypes = {
			"Any",
			"Cloth",
			"Leather",
			"Mail",
			"Plate",
			"Miscellaneous",
			"Shields" },

	Classes = {
			"Warlock",
			"Warrior",
			"Shaman",
			"Mage",
			"Hunter",
			"Priest",
			"Paladin",
			"Rogue",
			"Druid" },
			
	ClassGroups = {
			"Cloth",
			"Leather",
			"Mail",
			"Plate"		},
				
	OutputTo = {
			"Channel",
			"Guild",
			"Raid",
			"Party",
			"Say" },	
				
	OutputLimit = {
			5,
			10,
			15,
			20 },								
};

local DKPM_CPTabs = {
	{ "Play", "Player DKP" },
	{ "Hotbar Mods", "Raid History" },
	{ "Database Statistics", "Item History"},
};

DKPM_TITLE = "DKP_Matrix";
DKPM_SEARCH_TITLE = "DKP_Matrix Search";
DKPM_DETAILED_RAID_HISTORY_TITLE = "Raid History";
DKPM_DETAILED_ITEM_HISTORY_TITLE = "Item History";
DKPM_BUTTON_SEARCH = "Search";
DKPM_BUTTON_CANCEL = "Cancel";
DKPM_BUTTON_RESET	= "Reset";

DKPM_DETAILED_RAID_STATS = "-- Statistics --\n\n".. RED .."RAID Date\n".. WHITE .. "Jan 1, 06\n\n" ..  RED .."Total Players\n".. WHITE .. "40\n\n".. RED .."Class Distribution".. WHITE .."\nRogue .. 4%\nWarlock .. 8%\nPriest .. 5%\nDruid .. 2%\nWarrior .. 5%\n\n";	

CurrentPlayer = "thango";
CurrentRaid		= "";

DKP_DB_TEMP = {};

function DKPM_VariablesLoaded ()

	-- Initialize General Options
	if (DKPM_Options == nil) then
		DKPM_Options = {};
	end
	if (DKPM_Options.percision == nil) then
			DKPM_Options.percision = "%0.0f"; 
	end
	if (DKPM_Options.dbselect == nil) then
			DKPM_Options.dbselect = 1;
	end		
	
	
	-- Initialize Bot Options
	if (DKPMB_Options == nil) then
			DKPMB_Options = {};
	end			
	
	if (DKPMB_Options.BotEnabled == nil) then	
			DKPMB_Options.BotEnabled = 1;
			getglobal("DKPM_CPOptionsBotEnabledCheckBox"):SetChecked(1);		
	elseif (DKPMB_Options.BotEnabled == 1) then
			getglobal("DKPM_CPOptionsBotEnabledCheckBox"):SetChecked(1);				
	end				
	
	if (DKPMB_Options.LimitAccess == nil) then
			DKPMB_Options.LimitAccess = 1;
			getglobal("DKPM_CPOptionsBotLimitAccessCheckBox"):SetChecked(1);
	elseif (DKPMB_Options.LimitAccess == 1) then
			getglobal("DKPM_CPOptionsBotLimitAccessCheckBox"):SetChecked(1);
	end
				
	if (DKPMB_Options.BotATT == nil) then
			DKPMB_Options.BotATT = "rp";
			getglobal("DKPM_CPOptionsBotAttentionTextBox"):SetText(DKPMB_Options.BotATT);
	else
			getglobal("DKPM_CPOptionsBotAttentionTextBox"):SetText(DKPMB_Options.BotATT);
	end

	if (DKPMB_Options.WhisperPrefix == nil) then
			DKPMB_Options.WhisperPrefix = "@";
			getglobal("DKPM_CPOptionsWhisperPrefixTextBox"):SetText(DKPMB_Options.WhisperPrefix);
	else
			getglobal("DKPM_CPOptionsWhisperPrefixTextBox"):SetText(DKPMB_Options.WhisperPrefix);
	end
	
	if (DKPMB_Options.HideIncomingTells == nil) then
			DKPMB_Options.HideIncomingTells = 0;										
	elseif (DKPMB_Options.HideIncomingTells == 1) then
			getglobal("DKPM_CPOptionsBotHideIncomingCheckBox"):SetChecked(1);
	end
			
	if (DKPMB_Options.HideOutgoingTells == nil) then
			DKPMB_Options.HideOutgoingTells = 1;										
			getglobal("DKPM_CPOptionsBotHideOutgoingCheckBox"):SetChecked(1);
	elseif (DKPMB_Options.HideOutgoingTells == 1) then
			getglobal("DKPM_CPOptionsBotHideOutgoingCheckBox"):SetChecked(1);
	end	
	
	-- Initialize Updater (Sync) Options
	if (DKPMU_Options == nil) then
			DKPMU_Options = {};
	end	
	
	if (DKPMU_Options.dbactive == nil) then
			DKPMU_Options.dbactive = {};
			for i = 0, 4 do
					DKPMU_Options.dbactive[i] = true;
			end
	else
			
	end			
	
	if (DKPMU_Options.active == nil) then
			DKPMU_Options.active = true;
	elseif (DKPMU_Options.active == true) then
			DKPM_CPSyncEnableCheckBox:SetChecked(1);
	end	

	if (DKPMU_Options.autosync == nil) then
			DKPMU_Options.autosync = true;
			DKPM_CPAutoSyncEnableCheckBox:SetChecked(1);
			DKPM_CPAutoSyncNowButton:Disable();
	elseif (DKPMU_Options.autosync == true) then			
			DKPM_CPAutoSyncNowButton:Disable();
			DKPM_CPAutoSyncEnableCheckBox:SetChecked(1);
	end
	
	-- Initialize Output Options
	if (DKPM_OutputOptions == nil) then
			DKPM_OutputOptions = {};
	end			
		
	if (DKPM_OutputOptions.OutputChannel == nil) then
			DKPM_OutputOptions.OutputChannel = "guildch";						
	end
		
	if (DKPM_OutputOptions.OutputTo == nil) then
			DKPM_OutputOptions.OutputTo = 1;			
	end
		
	if (DKPM_OutputOptions.OutputLimit == nil) then
			DKPM_OutputOptions.OutputLimit = 1;			
	end		
			
	DKPM_CPSyncChannelTextBox:SetText(DKPMU_Options.channel);
	DKPM_CPOutputChannelTextBox:SetText(DKPM_OutputOptions.OutputChannel);
	
	-- Initialize Search Class Filters
	
	for i = 1, table.getn(DKPM_DropDownOptions.Classes) do
			getglobal("DKPM_PLSearchClass"..i.."CheckBoxText"):SetText(DKPM_ClassColors[string.lower(DKPM_DropDownOptions.Classes[i])]..DKPM_DropDownOptions.Classes[i]);
			getglobal("DKPM_PLSearchClass"..i.."CheckBox").Class = DKPM_DropDownOptions.Classes[i];
	end

	for i = 1, table.getn(DKPM_DropDownOptions.ClassGroups) do
			getglobal("DKPM_PLSearchClassGroup"..i.."CheckBoxText"):SetText(DKPM_DropDownOptions.ClassGroups[i]);
			getglobal("DKPM_PLSearchClassGroup"..i.."CheckBox").Class = DKPM_DropDownOptions.ClassGroups[i];
	end	
end

-- ####################################################################################--
-- event	event name
function DKPM_OnEvent( event )
		
		
		if ((event == "ADDON_LOADED") and (string.lower(arg1) == string.lower("dkp_matrix"))) then						
				
				-- Load up the data from file if it's there
				if (DKP_ROLL_PLAYERS == nil) then
						DEFAULT_CHAT_FRAME:AddMessage(DKPM_ERROR_SQLVARS_ERROR1);
						DEFAULT_CHAT_FRAME:AddMessage(DKPM_ERROR_SQLVARS_ERROR2);
						DEFAULT_CHAT_FRAME:AddMessage(DKPM_ERROR_SQLVARS_ERROR3);
						DEFAULT_CHAT_FRAME:AddMessage(DKPM_ERROR_SQLVARS_ERROR4);						
				end
				
				-- Set default options if not saved
				DKPM_VariablesLoaded();
				-- Set Options saved in savedvariables
				-- DEFAULT_CHAT_FRAME:AddMessage(DKPM_Options.percision);	
				if (DKPM_Options.percision ~= "%0.0f") then
						 getglobal("DKPM_CPOptionsDecimalCheckBox"):SetChecked(1);		
				end						
				
				-- Set current database
				--DKPM_CPOptionsDBDropDown_OnShow();
				local i = DKPM_Options.dbselect;				
				UIDropDownMenu_SetSelectedID(DKPM_CPOptionsDBDropDown, i);
												
				if (DKP_DB[i-1] ~= nil) then
						DKP_ROLL_PLAYERS = DKP_DB[i-1]['playerdata'];
						DKP_ROLL_RAIDS = DKP_DB[i-1]['raiddata'];
						DKP_ROLL_UPDATE_INFO = DKP_DB[i-1]['updatedata'];
				else
						DKP_ROLL_PLAYERS = {};
						DKP_ROLL_RAIDS = {};
						DKP_ROLL_UPDATE_INFO = {};					
				end
				
				DKPM_PlayerList_Update();
				DKPM_RaidHistoryList_Update();
				DKPM_IHItemList_Update();					
				
				-- Set Active DB Sync
				for i = 0, 4 do
						if (DKPMU_Options.dbactive[i] == true) then
								getglobal("DKPM_CPSyncDBListRow"..i.."SyncCheckBox"):SetChecked(1);		
						end						
				end
				
				UIDropDownMenu_SetSelectedID(DKPM_CPOutputOutputToDropDown, DKPM_OutputOptions.OutputTo);
				-- Hide/Show Channel textbox depending on whats selected
				if (DKPM_DropDownOptions.OutputTo[DKPM_OutputOptions.OutputTo] == "Channel") then
						DKPM_CPOutputChannelTextBox:Show();
				else
						DKPM_CPOutputChannelTextBox:Hide();
				end				
				
				if (debug) then
						DKPM_CPFrame:Show();
						DKPM_CPSyncFrame:Show();
						DKPM_CPOptionsFrame:Show();
						--DKPM_CPAttToggle();
						DKPM_SearchFrame:Show();
						DKPM_CPOutputFrame:Show();
				end				
		end
end

-- Called when DKP_Matrix is loaded
function DKPM_OnLoad() 				

				--RegisterForSave("DKPM_Options");

    		-- Savedvariable.lua values load
    		this:RegisterEvent("ADDON_LOADED");

		    -- respond to bot whispers
		    --this:RegisterEvent("CHAT_MSG_WHISPER");
		    --this:RegisterEvent("CHAT_MSG_WHISPER_INFORM");		    		    
		    								
				-- Command Handler
				SLASH_DKP_MATRIX1 = "/dkpmatrix";
				SLASH_DKP_MATRIX1 = "/dkpm";
				SlashCmdList["DKP_MATRIX"] = function( msg )
						DKPM_SlashCommandHandler( msg );
				end
				
				for i = 1, 3 do
					getglobal("DKPM_CPTabButton" .. i):SetText( DKPM_CPTabs[i][2]);
					getglobal("DKPM_CPTabButton" .. i).tooltiptext = DKPM_CPTabs[i][2];
				end					
				getglobal("DKPM_CPTabButton1"):Disable();
				DKPM_CPFrameButtonSearch:Enable();
				--DKPM_CPFrameButtonOptions:Disable();	
				--DKPM_CPFrame:Hide();						
								
				--oldMouseDown=WorldFrame:GetScript("OnMouseUp");
				--WorldFrame:SetScript("OnMouseUp",myFunc);														
end

-- ############################################################################################
-- ## Slash Command Handlers

-- Handles all /roll commands
function DKPM_SlashCommandHandler( msg )
	
	local msgArgs;
	local numArgs;
	
	-- Get the arguments
	msg = string.lower(msg);
	msgArgs = GetArgs(msg, " ");
	
	-- Get the number of arguments
	numArgs = table.getn(msgArgs);
				
	-- Check if command is for DKP, for 1 argument only
	if (numArgs == 0) then	
			--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: Interface Toggled");
			if( not DKPM_CPFrame:IsVisible() )then
					DKPM_CPFrame:Show();
					
			else
					DKPM_CPFrame:Hide();
			end
	elseif (numArgs == 1) then								
			if (msgArgs[1] == "start") then
					DEFAULT_CHAT_FRAME:AddMessage(GREEN.. "DKP_Matrix: Synchronization Enabled.");
					DKPMU_Options.active = true;
			elseif  (msgArgs[1] == "stop") then
					DEFAULT_CHAT_FRAME:AddMessage(RED.. "DKP_Matrix: Synchronization Disabled.");
					DKPMU_Options.active = false;
			end
	end
end

function DKPM_CPSetTab(id)
	--DEFAULT_CHAT_FRAME:AddMessage(this:GetID());
	
	for i = 1, 3 do
		if (i == id) then
				getglobal("DKPM_CPTabButton".. i):Disable();
		else
			getglobal("DKPM_CPTabButton".. i):Enable();
		end
	end
	
	if (id == 1) then
			DKPM_Enable_PL()
	elseif (id == 2) then
			DKPM_Enable_RH()
	else
			DKPM_Enable_IH()
	end			
	
	--getglobal("DKPSYS_CPTabButton1"):SetDisabledTexture();	

end

function DKPM_Enable_PL()
			DKPM_CPFrameButtonAttDetail:Enable();
			DKPM_CPFrameButtonExtraDetail:Enable();
			DKPM_CPFrameButtonSearch:Enable();
			DKPM_CPFrameButtonReset:Enable();
			DKPM_CPFrameButtonOutput:Enable();						
			
			DKPM_CPFramePL:Show();			
			DKPM_CPFrameRH:Hide();
			DKPM_CPFrameIH:Hide();
			DKPM_CPDetailedFrame:Hide();
			
			DKPM_PLSearchFrame:Show();
			DKPM_IHSearchFrame:Hide();
			
			DKPM_SearchFrame:SetHeight(175);
			DKPM_SearchFrame:SetWidth(290);
			
end

function DKPM_Enable_RH()
			DKPM_CPFrameButtonExtraDetail:Enable();
			DKPM_CPFrameButtonAttDetail:Disable();
			DKPM_CPFrameButtonSearch:Disable();
			DKPM_CPFrameButtonReset:Disable();
			DKPM_CPFrameButtonOutput:Disable();
			
			DKPM_CPOutputFrame:Hide();
			
			DKPM_SearchFrame:Hide();
			DKPM_CPFramePL:Hide();
			DKPM_CPFrameIH:Hide();			
			DKPM_CPFrameRH:Show();
			DKPM_CPDetailedFrame:Hide();
			DKPM_CPOutputFrame:Hide();	
			DKPM_CPAttHide();
end

function DKPM_Enable_IH()
			DKPM_CPFrameButtonExtraDetail:Disable();
			DKPM_CPFrameButtonAttDetail:Disable();
			DKPM_CPFrameButtonSearch:Enable();
			DKPM_CPFrameButtonReset:Enable();
			DKPM_CPFrameButtonOutput:Disable();						
			
			--DKPM_SearchFrame:Hide();
			DKPM_CPFramePL:Hide();
			DKPM_CPFrameRH:Hide();
			DKPM_CPFrameIH:Show();				
			DKPM_CPDetailedFrame:Hide();
			
			DKPM_IHSearchFrame:Show();
			
			DKPM_PLSearchFrame:Hide();			
			DKPM_CPOutputFrame:Hide();
			DKPM_SearchFrame:SetHeight(140);
			DKPM_SearchFrame:SetWidth(335);
			DKPM_CPAttHide();
end

function DKPM_ToggleSearch ()
			--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: Search Interface Toggled");
			if( not DKPM_SearchFrame:IsVisible() )then
					DKPM_SearchFrame:Show();
					
			else
					DKPM_SearchFrame:Hide();
			end
end


function DKPM_CPDetailedToggle ()
			--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: Search Interface Toggled");
			if( not DKPM_CPDetailedFrame:IsVisible() )then
					DKPM_CPDetailedFrame:Show();
					this.ToolTip = "Hide Detailed Information";
					GameTooltip:SetText(this.ToolTip, 1, 1, 1,  1, 1);
			else
					DKPM_CPDetailedFrame:Hide();
					this.ToolTip = "Show Detailed Information";				
					GameTooltip:SetText(this.ToolTip, 1, 1, 1,  1, 1);
			end
end

function DKPM_CPAttHide ()
		for line=1,23 do
				getglobal("DKPM_PLRow"..line.."Texture"):SetWidth(300);
				getglobal("DKPM_PLRow"..line):SetWidth(320);
		end
		DKPM_CPAttendanceFrame:Hide();
		DKPM_CPFrameButtonAttDetail.ToolTip = "Show Attendance Information";
end

function DKPM_CPAttToggle ()
			--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: Search Interface Toggled");
			if( not DKPM_CPAttendanceFrame:IsVisible() )then
					for line=1,23 do
							getglobal("DKPM_PLRow"..line.."Texture"):SetWidth(430);
							getglobal("DKPM_PLRow"..line):SetWidth(440);
					end
					DKPM_CPAttendanceFrame:Show();
					this.ToolTip = "Hide Attendance Information";
					GameTooltip:SetText(this.ToolTip, 1, 1, 1,  1, 1);
			else
					for line=1,23 do
							getglobal("DKPM_PLRow"..line.."Texture"):SetWidth(300);
							getglobal("DKPM_PLRow"..line):SetWidth(320);
					end				
					DKPM_CPAttendanceFrame:Hide();
					this.ToolTip = "Show Attendance Information";
					GameTooltip:SetText(this.ToolTip, 1, 1, 1,  1, 1);
			end
end

function DKPM_Column_SetWidth(width, frame)
	if ( not frame ) then
		frame = this;
	end
	frame:SetWidth(width);
	getglobal(frame:GetName().."Middle"):SetWidth(width - 9);
end

function DKPM_PlayerClicked(id,clickfrom)		

		if (clickfrom == "detailed") then
				CurrentPlayer = getglobal("DKPM_DetailedRaidPlayerRow".. id .."PlayerName"):GetText();		
		else
				CurrentPlayer = this.PlayerName;		
		end
		CurrentPlayer = strlower(CurrentPlayer);
		getglobal("DKPM_CPDetailedHeaderTitle"):SetText("Raid/Item History for [ "..CapName(CurrentPlayer).." ]");
		--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: ".. CurrentPlayer);
		
		DKPM_CPDetailedFrame:Show();
		DKPM_CPDetailedFramePlayer:Show();
		DKPM_CPDetailedFrameRaid:Hide();		
		
		DKPM_PlayerItemList_Update();
		DKPM_PlayerRaidList_Update();
end

function DKPM_RaidClicked(id,clickfrom)		

		if (clickfrom == "detailed") then
				CurrentRaid = getglobal("DKPM_CPDetailedPlayerRaidRow".. id .."RaidID"):GetText();		
		else
				CurrentRaid = getglobal("DKPM_RHRow".. id .."RaidID"):GetText();		
		end
		local RaidPlayers = 0;
		for player, data in DKP_ROLL_RAIDS[CurrentRaid]['raid_attendees'] do
				RaidPlayers=RaidPlayers+1;
		end
						
		local RaidStats = "-- Statistics --\n\n".. RED 
											.."RAID Date\n".. WHITE .. DKP_ROLL_RAIDS[CurrentRaid]['raid_date'] ..  RED 
											.."\n\nTotal Players\n".. WHITE
											..RaidPlayers.. RED .."\n\nClass Distribution".. WHITE;
											
		for class, data in DKP_ROLL_RAIDS[CurrentRaid]['class_distribution'] do
		  	RaidStats = RaidStats .. "\n(".. data['total'] ..") ".. class .." ... ".. data['percent'] .."%";	
	  end
		
		--CurrentPlayer = strlower(CurrentPlayer);
		getglobal("DKPM_CPDetailedHeaderTitle"):SetText( DKP_ROLL_RAIDS[CurrentRaid]['raid_name'] );
		getglobal("DKPM_CPDetailedRaidStatsText"):SetText(RaidStats);
		--raid_date
		--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: ".. CurrentRaid);
		
		DKPM_CPDetailedFrame:Show();
		DKPM_CPDetailedFramePlayer:Hide();
		DKPM_CPDetailedFrameRaid:Show();
		
		DKPM_DetailedRaidPlayerList_Update();
		DKPM_DetailedRaidItemList_Update();
--		DKPM_PlayerItemList_Update();
--		DKPM_PlayerRaidList_Update();
end

function DKPM_Column_OnClick()
		-- Set sort type
		
		if (DKPM_ColumnSort[this.Column] == this.sortType) then
				DKPM_ColumnSort[this.Column] = this.sortType .."_dec";
		else
				DKPM_ColumnSort[this.Column] = this.sortType;		
		end	
		
		if (this.Column == "RaidHistoryList") then
				DKPM_RaidHistoryList_Update();				
		elseif (this.Column == "DetailedRaidPlayerList") then
				DKPM_DetailedRaidPlayerList_Update();
		elseif (this.Column == "DetailedRaidItemList") then
				DKPM_DetailedRaidItemList_Update();
		elseif (this.Column == "PlayerList") then
				DKPM_PlayerList_Update();
		elseif (this.Column == "PlayerRaidList") then
				DKPM_PlayerRaidList_Update();
		elseif (this.Column == "PlayerItemList") then
				DKPM_PlayerItemList_Update();
		elseif (this.Column == "ItemHistoryItemList") then
				DKPM_IHItemList_Update();
		end
		
		
end

function DKPM_RaidHistoryList_Update()
		local items = 0;
		local line = 0;
		
		local arrayRaidName = {};
		local arrayWorth = {};
		local arrayAttendees = {};
		local arrayDate = {};

	local line = 0;	
	local players = 0;	
	
	local SortedRaids = {};
	local SortIndex = {};
	
	local arrayRaidID = {};
	local arrayRaidName = {};
	local arrayRaidWorth = {};
	local arrayRaidAttendees = {};
	local arrayRaidDate = {}; 
	
	local iRaids = 1;	
	for raidTimeStamp, raidData in DKP_ROLL_RAIDS do

			table.insert(arrayRaidID, raidTimeStamp);
			table.insert(arrayRaidName, DKP_ROLL_RAIDS[raidTimeStamp]['raid_name']);
			table.insert(arrayRaidWorth, DKP_ROLL_RAIDS[raidTimeStamp]['raid_worth']);
			table.insert(arrayRaidAttendees, table.getn(DKP_ROLL_RAIDS[raidTimeStamp]['raid_attendees']));
			table.insert(arrayRaidDate, DKP_ROLL_RAIDS[raidTimeStamp]['raid_date']);
									
			table.insert(SortIndex, iRaids);
			iRaids = iRaids + 1;					
	end
	
	if (DKPM_ColumnSort.RaidHistoryList == "raidname") then
			table.sort(SortIndex, function(a,b) return arrayRaidName[a]>arrayRaidName[b] end)
	elseif (DKPM_ColumnSort.RaidHistoryList == "raidname_dec") then	
			table.sort(SortIndex, function(b,a) return arrayRaidName[a]>arrayRaidName[b] end)
	elseif (DKPM_ColumnSort.RaidHistoryList == "worth") then
			table.sort(SortIndex, function(a,b) return arrayRaidWorth[a]>arrayRaidWorth[b] end)
	elseif (DKPM_ColumnSort.RaidHistoryList == "worth_dec") then
			table.sort(SortIndex, function(b,a) return arrayRaidWorth[a]>arrayRaidWorth[b] end)
	elseif (DKPM_ColumnSort.RaidHistoryList == "attend") then
			table.sort(SortIndex, function(a,b) return arrayRaidAttendees[a]>arrayRaidAttendees[b] end)
	elseif (DKPM_ColumnSort.RaidHistoryList == "attend_dec") then
			table.sort(SortIndex, function(b,a) return arrayRaidAttendees[a]>arrayRaidAttendees[b] end)
	elseif (DKPM_ColumnSort.RaidHistoryList == "date") then
			table.sort(SortIndex, function(a,b) return arrayRaidID[a]>arrayRaidID[b] end)
	elseif (DKPM_ColumnSort.RaidHistoryList == "date_dec") then
			table.sort(SortIndex, function(b,a) return arrayRaidID[a]>arrayRaidID[b] end)
	end
	
	FauxScrollFrame_Update(DKPM_CPScrollRaidHistoryFrame, table.getn(SortIndex), 23, 18);			
			
	for line=1,23 do 
			lineplusoffset = line + FauxScrollFrame_GetOffset(DKPM_CPScrollRaidHistoryFrame);
			if (lineplusoffset <= table.getn(SortIndex)) then
					getglobal("DKPM_RHRow"..line):Show();
				 --DEFAULT_CHAT_FRAME:AddMessage(lineplusoffset .." ".. arrayRaidName[SortIndex[lineplusoffset]]);
					getglobal("DKPM_RHRow"..line.."RaidID"):SetText(arrayRaidID[SortIndex[lineplusoffset]]);
					getglobal("DKPM_RHRow"..line.."RaidName"):SetText(arrayRaidName[SortIndex[lineplusoffset]]);
					getglobal("DKPM_RHRow"..line.."Worth"):SetText(arrayRaidWorth[SortIndex[lineplusoffset]]);
					getglobal("DKPM_RHRow"..line.."Attendees"):SetText(arrayRaidAttendees[SortIndex[lineplusoffset]]);
					getglobal("DKPM_RHRow"..line.."Date"):SetText(arrayRaidDate[SortIndex[lineplusoffset]]);
			else
					getglobal("DKPM_RHRow"..line):Hide();
					--DEFAULT_CHAT_FRAME:AddMessage(lineplusoffset);
			end
	end		
		
end


function DKPM_DetailedRaidPlayerList_Update()
	local line = 0;
	
	local SortIndex = {};
	local arrayPlayers = {};
	local arrayClasses = {};
	local arrayDate = {};
	
	if (DKP_ROLL_RAIDS[CurrentRaid] == nil) then
			for line=1,11 do
					getglobal("DKPM_DetailedRaidPlayerRow"..line):Hide();
			end
			FauxScrollFrame_Update(DKPM_CPScrollRaidPlayerFrame, 0, 11, 18);
			return;
	end
	
	local iPlayers = 1;
	for index, playerName in DKP_ROLL_RAIDS[CurrentRaid]['raid_attendees'] do
			table.insert(SortIndex, iPlayers);
			table.insert(arrayPlayers, playerName);
			table.insert(arrayClasses, DKP_ROLL_PLAYERS[playerName]['Class']);
			iPlayers = iPlayers + 1;
	end
		
	if (DKPM_ColumnSort.DetailedRaidPlayerList == "playername") then
			table.sort(SortIndex, function(a,b) return arrayPlayers[a]>arrayPlayers[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidPlayerList == "playername_dec") then	
			table.sort(SortIndex, function(b,a) return arrayPlayers[a]>arrayPlayers[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidPlayerList == "class") then
			table.sort(SortIndex, function(a,b) return arrayClasses[a]>arrayClasses[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidPlayerList == "class_dec") then
			table.sort(SortIndex, function(b,a) return arrayClasses[a]>arrayClasses[b] end)
	end		
		
	FauxScrollFrame_Update(DKPM_CPScrollRaidPlayerFrame, table.getn(SortIndex), 11, 18);
	for line=1,11 do 
			lineplusoffset = line + FauxScrollFrame_GetOffset(DKPM_CPScrollRaidPlayerFrame);
			if (lineplusoffset <= table.getn(SortIndex)) then
					getglobal("DKPM_DetailedRaidPlayerRow"..line):Show();								
					getglobal("DKPM_DetailedRaidPlayerRow"..line.."PlayerName"):SetText(CapName(arrayPlayers[SortIndex[lineplusoffset]]));
					getglobal("DKPM_DetailedRaidPlayerRow"..line.."Class"):SetText(arrayClasses[SortIndex[lineplusoffset]]);
			else
					getglobal("DKPM_DetailedRaidPlayerRow"..line):Hide();
			end
	end
	
	--DEFAULT_CHAT_FRAME:AddMessage("done");
end

function DKPM_DetailedRaidItemList_Update()
	local line = 0;
	
	local SortIndex = {};	
	local arrayItem = {};
	local arrayDKP = {};
	local arrayLootedBy = {};
	
	if (DKP_ROLL_RAIDS[CurrentRaid] == nil) then
			for line=1,6 do
					getglobal("DKPM_DetailedRaidItemsRow"..line):Hide();
			end
			FauxScrollFrame_Update(DKPM_CPDetailedRaidItemsScroll, 0, 6, 18);
			return;                
	end
	
	local iItems = 1;
	if (DKP_ROLL_RAIDS[CurrentRaid]['raid_items'] ~= nil) then
					for itemName, itemData in DKP_ROLL_RAIDS[CurrentRaid]['raid_items'] do					
							table.insert(SortIndex, iItems);
							table.insert(arrayItem, itemName);
							table.insert(arrayDKP, itemData['value']);
							table.insert(arrayLootedBy, itemData['buyer']);													
													  
							iItems = iItems + 1;
					end			
	end
	
	
	if (DKPM_ColumnSort.DetailedRaidItemList == "itemname") then
			table.sort(SortIndex, function(a,b) return arrayItem[a]>arrayItem[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidItemList == "itemname_dec") then	
			table.sort(SortIndex, function(b,a) return arrayItem[a]>arrayItem[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidItemList == "dkp") then
			table.sort(SortIndex, function(a,b) return arrayDKP[a]>arrayDKP[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidItemList == "dkp_dec") then
			table.sort(SortIndex, function(b,a) return arrayDKP[a]>arrayDKP[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidItemList == "lootedby") then
			table.sort(SortIndex, function(a,b) return arrayLootedBy[a]>arrayLootedBy[b] end)
	elseif (DKPM_ColumnSort.DetailedRaidItemList == "lootedby_dec") then
			table.sort(SortIndex, function(b,a) return arrayLootedBy[a]>arrayLootedBy[b] end)
	end		

	
	--DEFAULT_CHAT_FRAME:AddMessage("Lising Players for raid : ".. CurrentRaid .." items:".. items);
	
	FauxScrollFrame_Update(DKPM_CPDetailedRaidItemsScroll, table.getn(SortIndex), 6, 18);
	for line=1,6 do        
			lineplusoffset = line + FauxScrollFrame_GetOffset(DKPM_CPDetailedRaidItemsScroll);
			if (lineplusoffset <= table.getn(SortIndex)) then
					local itemcolor = DKPM_GetItemColor(arrayItem[SortIndex[lineplusoffset]]);			
			
					getglobal("DKPM_DetailedRaidItemsRow"..line):Show();								
					getglobal("DKPM_DetailedRaidItemsRow"..line.."ItemPlain"):SetText(arrayItem[SortIndex[lineplusoffset]]);										
					if (itemcolor ~= nil) then
							getglobal("DKPM_DetailedRaidItemsRow"..line.."ItemName"):SetText("|c".. itemcolor .. arrayItem[SortIndex[lineplusoffset]]);							
					else
							getglobal("DKPM_DetailedRaidItemsRow"..line.."ItemName"):SetText(arrayItem[SortIndex[lineplusoffset]]);
					end								
					getglobal("DKPM_DetailedRaidItemsRow"..line.."DKP"):SetText(arrayDKP[SortIndex[lineplusoffset]]);
					getglobal("DKPM_DetailedRaidItemsRow"..line.."LootedBy"):SetText(CapName(arrayLootedBy[SortIndex[lineplusoffset]]));
			else
					getglobal("DKPM_DetailedRaidItemsRow"..line):Hide();
			end
	end
	
	--DEFAULT_CHAT_FRAME:AddMessage("done");
end


-- **************************************************
-- Options Functions
-- **************************************************

function DKPM_CPOptionsToggle ()
			--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: Search Interface Toggled");
			if( not DKPM_CPOptionsFrame:IsVisible() )then
					DKPM_CPOptionsFrame:Show();
			else
					DKPM_CPOptionsFrame:Hide();
			end
end

--------------------------------
-- Database Drop Down
--------------------------------

function DKPM_CPOptionsDBDropDown_Initialize()
	local info;
	for i = 0, getn(DKP_DB), 1 do
		info = {
			text = DKP_DB[i]['dbname'];
			func = DKPM_CPOptionsDBDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_CPOptionsDBDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_CPOptionsDBDropDown, DKPM_CPOptionsDBDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_CPOptionsDBDropDown, DKPM_Options.dbselect);
	UIDropDownMenu_SetWidth(140);
end

function DKPM_CPOptionsDBDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_CPOptionsDBDropDown, i);
	DKPM_Options.dbselect = i;
	
	DKP_ROLL_PLAYERS = DKP_DB[i-1]['playerdata'];
	DKP_ROLL_RAIDS = DKP_DB[i-1]['raiddata'];
	DKP_ROLL_UPDATE_INFO = DKP_DB[i-1]['updatedata'];
	
	DKPM_PlayerList_Update();
	DKPM_RaidHistoryList_Update();
	DKPM_IHItemList_Update();
end
         
function DKPM_CPOptionsSetPercision_OnClick()

	local percision = getglobal("DKPM_CPOptionsDecimalCheckBox"):GetChecked();		
	
	if (percision == 1) then
			DKPM_Options.percision = "%0.2f";
	else
			DKPM_Options.percision = "%0.0f";
	end
	
	DKPM_PlayerList_Update();
	DKPM_RaidHistoryList_Update();
	DKPM_DetailedRaidPlayerList_Update();
	DKPM_DetailedRaidItemList_Update();
end

-- Bot Options

function DKPM_CPOptionsBotEnabled_OnClick()
	local enabled = getglobal("DKPM_CPOptionsBotEnabledCheckBox"):GetChecked();		
	if (enabled == nil) then enabled = 0; end
	DKPMB_Options.BotEnabled = enabled;
end

function DKPM_CPOptionsBotLimitAccess_OnClick()
	local enabled = getglobal("DKPM_CPOptionsBotLimitAccessCheckBox"):GetChecked();		
	if (enabled == nil) then enabled = 0; end	
	DKPMB_Options.LimitAccess = enabled;	
end

function DKPM_CPOptionsBotHideIncoming_OnClick()
	local enabled = getglobal("DKPM_CPOptionsBotHideIncomingCheckBox"):GetChecked();		
	if (enabled == nil) then enabled = 0; end	
	DKPMB_Options.HideIncomingTells = enabled;	
end

function DKPM_CPOptionsBotHideOutgoing_OnClick()
	local enabled = getglobal("DKPM_CPOptionsBotHideOutgoingCheckBox"):GetChecked();		
	if (enabled == nil) then enabled = 0; end	
	DKPMB_Options.HideOutgoingTells = enabled;	
end

function DKPM_CPOptionsBotATT_Update()
		
		local str = string.lower(getglobal("DKPM_CPOptionsBotAttentionTextBox"):GetText());
		str = string.gsub(str, "[^a-zA-Z]", "")
		str = string.gsub(str, " ", "")		
		getglobal("DKPM_CPOptionsBotAttentionTextBox"):SetText(str);
		
		if ((DKPMB_Options.BotATT ~= str) and (str ~= "")) then												
				DKPMB_Options.BotATT = str;
		end		
end

function DKPM_CPOptionsBotWhisperPrefix_Update()
		
		local str = getglobal("DKPM_CPOptionsWhisperPrefixTextBox"):GetText();				
		str = string.gsub(str, " ", "");

		getglobal("DKPM_CPOptionsWhisperPrefixTextBox"):SetText(str);
		
		if ((DKPMB_Options.WhisperPrefix ~= str) and (str ~= "")) then												
				DKPMB_Options.WhisperPrefix = str;
		end		
end

-- **************************************************
-- DKP Output Functions
-- **************************************************

function DKPM_CPOutputToggle ()
			--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: Search Interface Toggled");
			if( not DKPM_CPOutputFrame:IsVisible() )then
					DKPM_CPOutputFrame:Show();
			else
					DKPM_CPOutputFrame:Hide();
			end
end


-- Output To Drop Down
function DKPM_CPOutputOutputToDropDown_Initialize()
	local info;
	for i = 1, getn(DKPM_DropDownOptions['OutputTo']), 1 do
		info = {
			text = DKPM_DropDownOptions['OutputTo'][i];
			func = DKPM_CPOutputOutputToDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_CPOutputOutputToDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_CPOutputOutputToDropDown, DKPM_CPOutputOutputToDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_CPOutputOutputToDropDown, DKPM_OutputOptions.OutputTo);
	UIDropDownMenu_SetWidth(70);	
end

function DKPM_CPOutputOutputToDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_CPOutputOutputToDropDown, i);
	DKPM_OutputOptions.OutputTo = i;
	
	if (DKPM_DropDownOptions.OutputTo[i] == "Channel") then
			DKPM_CPOutputChannelTextBox:Show();
	else
			DKPM_CPOutputChannelTextBox:Hide();
	end

end


-- Output To Drop Down
function DKPM_CPOutputOutputLimitDropDown_Initialize()
	local info;
	for i = 1, getn(DKPM_DropDownOptions['OutputLimit']), 1 do
		info = {
			text = DKPM_DropDownOptions['OutputLimit'][i];
			func = DKPM_CPOutputOutputLimitDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_CPOutputOutputLimitDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_CPOutputOutputLimitDropDown, DKPM_CPOutputOutputLimitDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_CPOutputOutputLimitDropDown, 1);
	UIDropDownMenu_SetWidth(40);
end

function DKPM_CPOutputOutputLimitDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_CPOutputOutputLimitDropDown, i);
	DKPM_OutputOptions.OutputLimit = i;

end

function DKPM_OutputChannel_Update()
		DKPM_OutputOptions.OutputChannel = DKPM_CPOutputChannelTextBox:GetText();		
end

function DKPM_OutputDKP()
	local OutputLimit = DKPM_DropDownOptions['OutputLimit'][DKPM_OutputOptions.OutputLimit];	
	local OutputChannel = DKPM_CPOutputChannelTextBox:GetText();	
	
	DKPM_OutputStr("<< DKP_Matrix Output >>");
	for line=1,OutputLimit do        										
			local PlayerName = getglobal("DKPM_PLRow"..line).PlayerName;
			local DKPCurrent = getglobal("DKPM_PLRow"..line).DKPCurrent;
			local DKPSpent = getglobal("DKPM_PLRow"..line).DKPSpent;
			local DKPOverall = getglobal("DKPM_PLRow"..line).DKPOverall;
			local Items = getglobal("DKPM_PLRow"..line).Items;
			local Class = getglobal("DKPM_PLRow"..line).Class;
		
			if (getglobal("DKPM_PLRow"..line):IsVisible()) then
					local outputstr = CapName(PlayerName) .." ... ".. DKPCurrent .." DKP";
					DKPM_OutputStr(outputstr);
			end
	end
end

function DKPM_OutputStr( msg ) 
		local OutputTo = DKPM_DropDownOptions['OutputTo'][DKPM_OutputOptions.OutputTo];	
		local OutputChannel = DKPM_CPOutputChannelTextBox:GetText();	

		if (OutputTo == 'Channel') then
				local id, name = GetChannelName(OutputChannel);					
				SendChatMessage(msg, "CHANNEL", nil, id);
		else
				SendChatMessage(msg, OutputTo);	
		end
end

-- **************************************************
-- Player List / Search Functions
-- **************************************************

-- Class Drop Down

function DKPM_PLClassDropDown_Initialize()
	local info;
	for i = 1, getn(DKPM_DropDownOptions['Classes']), 1 do
		info = {
			text = DKPM_DropDownOptions['Classes'][i];
			func = DKPM_PLClassDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_PLClassDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_PLSearchClassDropDown, DKPM_PLClassDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_PLSearchClassDropDown, 1);
	UIDropDownMenu_SetWidth(80);
end

function DKPM_PLClassDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_PLSearchClassDropDown, i);
	DKPM_SearchOptions.PLClass = i;
	DKPM_PlayerList_Update();
end

function DKP_PLSearchReset ()
	getglobal("DKPM_PLSearchPlayerTextBox"):SetText("");	

	-- Reset Class/ClassGroups Filiter
	
	for i = 1, table.getn(DKPM_DropDownOptions.Classes) do
			getglobal("DKPM_PLSearchClass"..i.."CheckBox"):SetChecked(0);			
	end

	for i = 1, table.getn(DKPM_DropDownOptions.ClassGroups) do
			getglobal("DKPM_PLSearchClassGroup"..i.."CheckBox"):SetChecked(0);
	end		

	DKPM_PLSearchRaidCheckBox:SetChecked(0);

	DKPM_PlayerList_Update();
end

function DKPM_PlayerList_Update()
	
	if (getglobal("DKPM_PLSearchPlayerTextBox") ~= nil) then	
			playersearchwords = string.lower(getglobal("DKPM_PLSearchPlayerTextBox"):GetText());		
			searchPlayerClass = string.lower(DKPM_DropDownOptions['Classes'][DKPM_SearchOptions.PLClass]);	
			searchPlayerRaid = getglobal("DKPM_PLSearchRaidCheckBox"):GetChecked();			
	else 			      
			playersearchwords = "";
			searchPlayerClass = "any";
			searchPlayerRaid = false;
	end
	
	local SortIndex = {};		
	local arrayPlayerName = {};
	local arrayDKPCurrent = {};
	local arrayDKPSpent = {};	
	local arrayDKPOverall = {};	
	local arrayItems = {};	
	local arrayClass = {};			
	local arrayAtt30 = {};
	local arrayAtt60 = {};
	local arrayAtt90 = {};
	local arrayAttLife = {};
	
	if (DKP_ROLL_PLAYERS == nil) then		
			for line=1,23 do
					getglobal("DKPM_PLRow"..line.."PlayerName"):SetText("No sqlvar.lua found");
					getglobal("DKPM_PLRow"..line.."DKPCurrent"):SetText("");
					getglobal("DKPM_PLRow"..line.."DKPSpent"):SetText("");
					getglobal("DKPM_PLRow"..line.."DKPOverall"):SetText("");
					getglobal("DKPM_PLRow"..line.."Items"):SetText("");
					getglobal("DKPM_PLRow"..line.."Class"):SetText("");					
			end
			return;
	end
	
	local classFilter = {};
	for i = 1, table.getn(DKPM_DropDownOptions.Classes) do
			if (getglobal("DKPM_PLSearchClass"..i.."CheckBox"):GetChecked() == 1) then
					table.insert(classFilter, getglobal("DKPM_PLSearchClass"..i.."CheckBox").Class);
			end					
	end			
	
	local classGroupFilter = {};
	for i = 1, table.getn(DKPM_DropDownOptions.ClassGroups) do
			if (getglobal("DKPM_PLSearchClassGroup"..i.."CheckBox"):GetChecked() == 1) then
					table.insert(classGroupFilter, getglobal("DKPM_PLSearchClassGroup"..i.."CheckBox").Class);
			end					
	end		
	
	local iPlayer = 1;	
	for playersname, playerdata in DKP_ROLL_PLAYERS do
			
			if (playerdata['Class'] == nil) then
					playerdata['Class'] = "N/A";
			end
			
			local playerGood = true;					
			local SearchWords = GetArgs(playersearchwords, " ");
			local iSearchWords = table.getn(SearchWords);
			
			if (iSearchWords > 0) then
					local somematch = false;
					for index, currentWord in SearchWords do							
							if (string.find( string.lower(playersname), currentWord, 1, true) ~= nil) then
									somematch = true;
							end
					end
					if (somematch == false) then
							playerGood = false;
					end
			end																							
			
			if ((table.getn(classFilter) > 0) or (table.getn(classGroupFilter) > 0)) then
					local matched = false;
					
					if (table.getn(classFilter) > 0) then
							for i = 1, table.getn(classFilter) do
									if (string.lower(playerdata['Class']) == string.lower(classFilter[i])) then
											matched = true;
									end																							
							end	
					end
					
					if (table.getn(classGroupFilter) > 0) then
							
							for i = 1, table.getn(classGroupFilter) do							
									searchPlayerClass = string.lower(classGroupFilter[i]);
						
									if (((searchPlayerClass == 'cloth') and ((string.lower(playerdata['Class']) == 'priest')
																								    	or (string.lower(playerdata['Class']) == 'mage') 
																									    or (string.lower(playerdata['Class']) == 'warlock'))) 
				
									 or ((searchPlayerClass == 'leather') and ((string.lower(playerdata['Class']) == 'druid')
																								    	or (string.lower(playerdata['Class']) == 'rogue')))
				
									 or ((searchPlayerClass == 'mail') and ((string.lower(playerdata['Class']) == 'shaman')
																								    	or (string.lower(playerdata['Class']) == 'hunter'))) 
																									    
									 or ((searchPlayerClass == 'plate') and ((string.lower(playerdata['Class']) == 'warrior')
																								    	or (string.lower(playerdata['Class']) == 'paladin')))  ) then	
											matched = true;
									end																							
							end	
					end					
					
					if (matched == false ) then
							playerGood = false;
					end
			end
			
			if (searchPlayerRaid == 1) then
					local playerinraid = false;
					for iRaidPlayer=1,GetNumRaidMembers() do
							local name, rank, subgroup, level, class, fileName, zone, online = GetRaidRosterInfo(iRaidPlayer);
													
							if (string.lower(name) == string.lower(playersname)) then
									playerinraid = true;
							end
					end
					if (playerinraid == false) then
							playerGood = false;
					end
			end
							
				
			if (playerGood == true) then										
					if (playerdata['RaidPoints'] == nil) then
							playerdata['RaidPoints'] = 0;
					end
			
					local items = 0;
					local pointsSpent = 0;
					if (playerdata['Items'] ~= nil) then
							for itemName, itemData in playerdata['Items'] do
									items = items + 1;
									pointsSpent = pointsSpent + itemData['cost'];
							end
					end			
										
					table.insert(SortIndex, iPlayer);
					table.insert(arrayPlayerName, CapName(playersname));
					table.insert(arrayDKPCurrent, playerdata['RaidPoints']);
					table.insert(arrayDKPSpent, pointsSpent);
					table.insert(arrayDKPOverall, playerdata['RaidPoints']+pointsSpent);
					table.insert(arrayItems, items);		
					table.insert(arrayClass, playerdata['Class']);
					table.insert(arrayAtt30, playerdata['Att30']);
					table.insert(arrayAtt60, playerdata['Att60']);
					table.insert(arrayAtt90, playerdata['Att90']);
					table.insert(arrayAttLife, playerdata['AttLife']);
					
					iPlayer=iPlayer+1;	
			end		
	end	
	FauxScrollFrame_Update(DKPM_PLScrollFrame, table.getn(SortIndex), 23, 18);
	
	if (DKPM_ColumnSort.PlayerList == "playername") then
			table.sort(SortIndex, function(a,b) return arrayPlayerName[a]>arrayPlayerName[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "playername_dec") then	
			table.sort(SortIndex, function(b,a) return arrayPlayerName[a]>arrayPlayerName[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "dkpcurrent") then
			table.sort(SortIndex, function(a,b) return arrayDKPCurrent[a]>arrayDKPCurrent[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "dkpcurrent_dec") then	
			table.sort(SortIndex, function(b,a) return arrayDKPCurrent[a]>arrayDKPCurrent[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "dkpspent") then
			table.sort(SortIndex, function(a,b) return arrayDKPSpent[a]>arrayDKPSpent[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "dkpspent_dec") then	
			table.sort(SortIndex, function(b,a) return arrayDKPSpent[a]>arrayDKPSpent[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "dkpoverall") then
			table.sort(SortIndex, function(a,b) return arrayDKPOverall[a]>arrayDKPOverall[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "dkpoverall_dec") then	
			table.sort(SortIndex, function(b,a) return arrayDKPOverall[a]>arrayDKPOverall[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "items") then
			table.sort(SortIndex, function(a,b) return arrayItems[a]>arrayItems[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "items_dec") then	
			table.sort(SortIndex, function(b,a) return arrayItems[a]>arrayItems[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "class") then
			table.sort(SortIndex, function(a,b) return arrayClass[a]>arrayClass[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "class_dec") then	
			table.sort(SortIndex, function(b,a) return arrayClass[a]>arrayClass[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "att30") then	
			table.sort(SortIndex, function(a,b) return arrayAtt30[a]>arrayAtt30[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "att30_dec") then	
			table.sort(SortIndex, function(b,a) return arrayAtt30[a]>arrayAtt30[b] end)			
	elseif (DKPM_ColumnSort.PlayerList == "att60") then	
			table.sort(SortIndex, function(a,b) return arrayAtt60[a]>arrayAtt60[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "att60_dec") then	
			table.sort(SortIndex, function(b,a) return arrayAtt60[a]>arrayAtt60[b] end)			
	elseif (DKPM_ColumnSort.PlayerList == "att90") then	
			table.sort(SortIndex, function(a,b) return arrayAtt90[a]>arrayAtt90[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "att90_dec") then	
			table.sort(SortIndex, function(b,a) return arrayAtt90[a]>arrayAtt90[b] end)			
	elseif (DKPM_ColumnSort.PlayerList == "attlife") then	
			table.sort(SortIndex, function(a,b) return arrayAttLife[a]>arrayAttLife[b] end)
	elseif (DKPM_ColumnSort.PlayerList == "attlife_dec") then	
			table.sort(SortIndex, function(b,a) return arrayAttLife[a]>arrayAttLife[b] end)			
			
	end	
	
	for line=1,23 do        
			local lineplusoffset = line + FauxScrollFrame_GetOffset(DKPM_PLScrollFrame);
			if (lineplusoffset <= table.getn(SortIndex)) then			
					getglobal("DKPM_PLRow"..line):Show();
					getglobal("DKPM_CPAttendanceRow"..line.."30Days"):Show();
					getglobal("DKPM_CPAttendanceRow"..line.."60Days"):Show();
					getglobal("DKPM_CPAttendanceRow"..line.."90Days"):Show();
					getglobal("DKPM_CPAttendanceRow"..line.."Lifetime"):Show();				
										
					getglobal("DKPM_PLRow"..line).PlayerName = arrayPlayerName[SortIndex[lineplusoffset]];
					getglobal("DKPM_PLRow"..line).DKPCurrent = arrayDKPCurrent[SortIndex[lineplusoffset]];
					getglobal("DKPM_PLRow"..line).DKPSpent = arrayDKPSpent[SortIndex[lineplusoffset]];
					getglobal("DKPM_PLRow"..line).DKPOverall = arrayDKPOverall[SortIndex[lineplusoffset]];
					getglobal("DKPM_PLRow"..line).Items = arrayItems[SortIndex[lineplusoffset]];
					getglobal("DKPM_PLRow"..line).Class = arrayClass[SortIndex[lineplusoffset]];
					
					local color = "";
					if (DKPM_ClassColors[string.lower(arrayClass[SortIndex[lineplusoffset]])] ~= nil) then
							color = DKPM_ClassColors[string.lower(arrayClass[SortIndex[lineplusoffset]])]
					end
	
					getglobal("DKPM_PLRow"..line.."PlayerName"):SetText(color..arrayPlayerName[SortIndex[lineplusoffset]]);
					getglobal("DKPM_PLRow"..line.."Class"):SetText(color..arrayClass[SortIndex[lineplusoffset]]);				
		
					
					if (arrayDKPCurrent[SortIndex[lineplusoffset]] > 0) then
							getglobal("DKPM_PLRow"..line.."DKPCurrent"):SetText(DKPM_DKPColors['positive']..format(DKPM_Options.percision, arrayDKPCurrent[SortIndex[lineplusoffset]]));
					elseif (arrayDKPCurrent[SortIndex[lineplusoffset]] == 0) then
							getglobal("DKPM_PLRow"..line.."DKPCurrent"):SetText(DKPM_DKPColors['neutral']..format(DKPM_Options.percision, arrayDKPCurrent[SortIndex[lineplusoffset]]));
					elseif (arrayDKPCurrent[SortIndex[lineplusoffset]] < 0) then
							getglobal("DKPM_PLRow"..line.."DKPCurrent"):SetText(DKPM_DKPColors['negative']..format(DKPM_Options.percision, arrayDKPCurrent[SortIndex[lineplusoffset]]));
					end
					if (arrayDKPSpent[SortIndex[lineplusoffset]] > 0) then
							getglobal("DKPM_PLRow"..line.."DKPSpent"):SetText(DKPM_DKPColors['positive']..format(DKPM_Options.percision, arrayDKPSpent[SortIndex[lineplusoffset]]));
					elseif (arrayDKPSpent[SortIndex[lineplusoffset]] == 0) then
							getglobal("DKPM_PLRow"..line.."DKPSpent"):SetText(DKPM_DKPColors['neutral']..format(DKPM_Options.percision, arrayDKPSpent[SortIndex[lineplusoffset]]));
					elseif (arrayDKPSpent[SortIndex[lineplusoffset]] < 0) then
							getglobal("DKPM_PLRow"..line.."DKPSpent"):SetText(DKPM_DKPColors['negative']..format(DKPM_Options.percision, arrayDKPSpent[SortIndex[lineplusoffset]]));
					end
					if (arrayDKPOverall[SortIndex[lineplusoffset]] > 0) then
							getglobal("DKPM_PLRow"..line.."DKPOverall"):SetText(DKPM_DKPColors['positive']..format(DKPM_Options.percision, arrayDKPOverall[SortIndex[lineplusoffset]]));
					elseif (arrayDKPOverall[SortIndex[lineplusoffset]] == 0) then
							getglobal("DKPM_PLRow"..line.."DKPOverall"):SetText(DKPM_DKPColors['neutral']..format(DKPM_Options.percision, arrayDKPOverall[SortIndex[lineplusoffset]]));
					elseif (arrayDKPOverall[SortIndex[lineplusoffset]] < 0) then
							getglobal("DKPM_PLRow"..line.."DKPOverall"):SetText(DKPM_DKPColors['negative']..format(DKPM_Options.percision, arrayDKPOverall[SortIndex[lineplusoffset]]));
					end
										
					--getglobal("DKPM_PLRow"..line.."DKPCurrent"):SetText(format(DKPM_Options.percision, arrayDKPCurrent[SortIndex[lineplusoffset]]));
					--getglobal("DKPM_PLRow"..line.."DKPSpent"):SetText(format(DKPM_Options.percision, arrayDKPSpent[SortIndex[lineplusoffset]]));
					--getglobal("DKPM_PLRow"..line.."DKPOverall"):SetText(format(DKPM_Options.percision, arrayDKPOverall[SortIndex[lineplusoffset]]));
					getglobal("DKPM_PLRow"..line.."Items"):SetText(arrayItems[SortIndex[lineplusoffset]]);
					 
					getglobal("DKPM_CPAttendanceRow"..line.."30Days"):SetText(color..arrayAtt30[SortIndex[lineplusoffset]].."%");
					getglobal("DKPM_CPAttendanceRow"..line.."60Days"):SetText(color..arrayAtt60[SortIndex[lineplusoffset]].."%");
					getglobal("DKPM_CPAttendanceRow"..line.."90Days"):SetText(color..arrayAtt90[SortIndex[lineplusoffset]].."%");
					getglobal("DKPM_CPAttendanceRow"..line.."Lifetime"):SetText(color..arrayAttLife[SortIndex[lineplusoffset]].."%");					
			else
					getglobal("DKPM_PLRow"..line):Hide();
					getglobal("DKPM_CPAttendanceRow"..line.."30Days"):Hide();
					getglobal("DKPM_CPAttendanceRow"..line.."60Days"):Hide();
					getglobal("DKPM_CPAttendanceRow"..line.."90Days"):Hide();
					getglobal("DKPM_CPAttendanceRow"..line.."Lifetime"):Hide();				
			end
	end
	
end

-- **************************************************
-- Item List / Search Functions
-- **************************************************

-- Binds Drop Down

function DKPM_IHBindsDropDown_Initialize()
	local info;
	for i = 1, getn(DKPM_DropDownOptions['Binds']), 1 do
		info = {
			text = DKPM_DropDownOptions['Binds'][i];
			func = DKPM_IHBindsDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_IHBindsDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_IHSearchBindsDropDown, DKPM_IHBindsDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchBindsDropDown, 1);
	UIDropDownMenu_SetWidth(90);
end

function DKPM_IHBindsDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchBindsDropDown, i);
	DKPM_SearchOptions.IHSearchBinds = i;
	DKPM_IHItemList_Update();
end

-- Rarity Drop Down

function DKPM_IHSearchRarityDropDown_Initialize()
	local info;
	for i = 1, getn(DKPM_DropDownOptions['Rarity']), 1 do
		info = {
			text = DKPM_DropDownOptions['Rarity'][i][1];
			func = DKPM_IHSearchRarityDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_IHSearchRarityDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_IHSearchRarityDropDown, DKPM_IHSearchRarityDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchRarityDropDown, 1);
	UIDropDownMenu_SetWidth(90);	
end

function DKPM_IHSearchRarityDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchRarityDropDown, i);
	DKPM_SearchOptions.IHRarity = i;
	DKPM_IHItemList_Update();
end


-- Equip Location Drop Down

function DKPM_IHSearchEquipLocDropDown_Initialize()
	local info;
	for i = 1, getn(DKPM_DropDownOptions['EquipTypes']), 1 do
		info = {
			text = DKPM_DropDownOptions['EquipTypes'][i];
			func = DKPM_IHSearchEquipLocDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_IHSearchEquipLocDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_IHSearchEquipLocDropDown, DKPM_IHSearchEquipLocDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchEquipLocDropDown, 1);
	UIDropDownMenu_SetWidth(90);
end

function DKPM_IHSearchEquipLocDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchEquipLocDropDown, i);
	DKPM_SearchOptions.EquipLoc = i;
	DKPM_IHItemList_Update();
end

-- Armor Type Drop Down

function DKPM_IHSearchArmorTypeDropDown_Initialize()
	local info;
	for i = 1, getn(DKPM_DropDownOptions['ArmorTypes']), 1 do
		info = {
			text = DKPM_DropDownOptions['ArmorTypes'][i];
			func = DKPM_IHSearchArmorTypeDropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end

function DKPM_IHSearchArmorTypeDropDown_OnShow()
	UIDropDownMenu_Initialize(DKPM_IHSearchArmorTypeDropDown, DKPM_IHSearchArmorTypeDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchArmorTypeDropDown, 1);
	UIDropDownMenu_SetWidth(65);
end

function DKPM_IHSearchArmorTypeDropDown_OnClick()
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchArmorTypeDropDown, i);
	DKPM_SearchOptions.IHArmorType = i;
	DKPM_IHItemList_Update();
end

function DKP_IHSearchReset ()
	getglobal("DKPM_IHSearchItemTextBox"):SetText("");	
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchArmorTypeDropDown, 1);
	DKPM_SearchOptions.IHArmorType = 1;
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchEquipLocDropDown, 1);	
	DKPM_SearchOptions.EquipLoc = 1;	
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchRarityDropDown, 1);
	DKPM_SearchOptions.IHRarity = 1;	
	UIDropDownMenu_SetSelectedID(DKPM_IHSearchBindsDropDown, 1);
	DKPM_SearchOptions.IHSearchBinds = 1;
	DKPM_IHItemList_Update();
end

function DKPM_IHItemList_Update()
	local line = 0;
	
	local SortIndex = {};
	local arrayItemName = {};
	local arrayDKP = {};
	local arrayLootedBy = {};		
	
	local itemsearchwords = string.lower(getglobal("DKPM_IHSearchItemTextBox"):GetText());	
	local itemBinds = DKPM_DropDownOptions['Binds'][DKPM_SearchOptions.IHSearchBinds];	
	local itemRarity = DKPM_DropDownOptions['Rarity'][DKPM_SearchOptions.IHRarity][3];
	local itemArmorType = DKPM_DropDownOptions['ArmorTypes'][DKPM_SearchOptions.IHArmorType];
	
	local iItems = 1;	
	for player, playerData in DKP_ROLL_PLAYERS do
			if (DKP_ROLL_PLAYERS[player]['Items'] ~= nil) then					
					for itemName, itemData in DKP_ROLL_PLAYERS[player]['Items'] do												
							local itemGood = true;					
							local itemLink = DKPM_GetItemLink(itemName);
							--DEFAULT_CHAT_FRAME:AddMessage(itemLink);
							local sName, sLink, iQuality, iLevel, sType, sSubType, iCount;
							if (itemLink ~= nil) then
									sName, sLink, iQuality, iLevel, sType, sSubType, iCount = GetItemInfo("item:".. itemLink);
							elseif ((itemLink == nil) and ((itemRarity ~= -1) or (itemArmorType ~= "Any"))) then
									-- If any of the search options are on, do not include unknown items
									itemGood = false;
							end
							local SearchWords = GetArgs(itemsearchwords, " ");
							local iSearchWords = table.getn(SearchWords);
							
							if (iSearchWords > 0) then
									local allmatch = true;
									for index, currentWord in SearchWords do							
											if (string.find( string.lower(itemName), currentWord, 1, true) == nil) then
													allmatch = false;
											end
									end
									if (allmatch == false) then
											itemGood = false;
									end
							end													
							if ((iQuality ~= nil) and (itemRarity ~= -1) and (iQuality ~= itemRarity)) then
									itemGood = false;									
							end
							if ((sSubType ~= nil) and (itemArmorType ~= "Any") and (sSubType ~= itemArmorType)) then
									itemGood = false;									
							end						
								
							if (itemGood == true) then
									table.insert(SortIndex, iItems);
									table.insert(arrayItemName, itemName);
									table.insert(arrayDKP, itemData['cost']);
									table.insert(arrayLootedBy, player);
									iItems = iItems + 1;								
							end
					end
			end
	end	
	FauxScrollFrame_Update(DKPM_IHItemListScroll, table.getn(SortIndex), 22, 18);
	
	if (DKPM_ColumnSort.ItemHistoryItemList == "itemname") then
			table.sort(SortIndex, function(a,b) return arrayItemName[a]>arrayItemName[b] end)
	elseif (DKPM_ColumnSort.ItemHistoryItemList == "itemname_dec") then	
			table.sort(SortIndex, function(b,a) return arrayItemName[a]>arrayItemName[b] end)
	elseif (DKPM_ColumnSort.ItemHistoryItemList == "dkp") then
			table.sort(SortIndex, function(a,b) return arrayDKP[a]>arrayDKP[b] end)
	elseif (DKPM_ColumnSort.ItemHistoryItemList == "dkp_dec") then	
			table.sort(SortIndex, function(b,a) return arrayDKP[a]>arrayDKP[b] end)
	elseif (DKPM_ColumnSort.ItemHistoryItemList == "lootedby") then
			table.sort(SortIndex, function(a,b) return arrayLootedBy[a]>arrayLootedBy[b] end)
	elseif (DKPM_ColumnSort.ItemHistoryItemList == "lootedby_dec") then	
			table.sort(SortIndex, function(b,a) return arrayLootedBy[a]>arrayLootedBy[b] end)
	end

	for line=1,22 do 
			lineplusoffset = line + FauxScrollFrame_GetOffset(DKPM_IHItemListScroll);
			if (lineplusoffset <= table.getn(SortIndex)) then
					getglobal("DKPM_IHItemListRow"..line):Show();
								
					local itemcolor = DKPM_GetItemColor(arrayItemName[SortIndex[lineplusoffset]]);			
					
					if (itemcolor ~= nil) then
							getglobal("DKPM_IHItemListRow"..line.."ItemName"):SetText("|c".. itemcolor .. arrayItemName[SortIndex[lineplusoffset]]);							
					else
							getglobal("DKPM_IHItemListRow"..line.."ItemName"):SetText(arrayItemName[SortIndex[lineplusoffset]]);
					end			
					getglobal("DKPM_IHItemListRow"..line.."ItemPlain"):SetText(arrayItemName[SortIndex[lineplusoffset]]);
					getglobal("DKPM_IHItemListRow"..line.."DKP"):SetText(format(DKPM_Options.percision, arrayDKP[SortIndex[lineplusoffset]]));
					getglobal("DKPM_IHItemListRow"..line.."LootedBy"):SetText(CapName(arrayLootedBy[SortIndex[lineplusoffset]]));	
			else
					getglobal("DKPM_IHItemListRow"..line):Hide();
			end
	end
end

function DKPM_ItemTooltip_OnEnter(name)

		local itemName = getglobal(name.."ItemPlain"):GetText();
		local itemLink = DKPM_GetItemLink(itemName);		
		
		if (itemLink ~= nil) then
				--DEFAULT_CHAT_FRAME:AddMessage("Lising Items for User: >".. itemLink.."<");
				GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT");
				GameTooltip:SetHyperlink("item:"..itemLink);				
		else
				--DEFAULT_CHAT_FRAME:AddMessage("Item Name: ".. itemName);
		end

end

function DKPM_ItemClicked(name) 
		
		local itemName = getglobal(name.."ItemPlain"):GetText();		
		local itemID = DKPM_GetItemLink(itemName);
		local itemColor = DKPM_GetItemColor(itemName);
		
		getglobal("DKPM_IHSearchItemTextBox"):ClearFocus();
		
		--DEFAULT_CHAT_FRAME:AddMessage("Linking Item: ".. itemID);
		
		if ((itemID ~= nil) and (itemColor)) then		
				local link = "|c".. itemColor .."|Hitem:".. itemID .."|h[".. itemName .."]|h|r";
		
		 		--if ( ChatFrameEditBox:IsVisible() ) then
		 			--DKPM_GetItemLink(); 		
		      ChatFrameEditBox:Insert(link);
		    --end
		end    
end

function DKPM_PlayerItem_OnClick(name)
		-- Goto Item search when user clicks on item in user profile
		
		local itemSearch = getglobal(name.."ItemPlain"):GetText();
		
		DKPM_CPSetTab(3);
		DKP_IHSearchReset();
		
		getglobal("DKPM_IHSearchItemTextBox"):SetText(itemSearch);	
		DKPM_IHItemList_Update();
end

function DKPM_PlayerItemList_Update()

	local line = 0;
	
	local SortIndex = {};
	local arrayItems = {};
	local arrayDKP = {};
	local arrayDate = {};
	
	if ((DKP_ROLL_PLAYERS[CurrentPlayer] == nil) or (DKP_ROLL_PLAYERS[CurrentPlayer]['Items'] == nil)) then
			for line=1,7 do
					getglobal("DKPM_CPDetailedPlayerItemsRow"..line):Hide();
			end
			FauxScrollFrame_Update(DKPM_CPDetailedPlayerItemsScroll, 0, 7, 18);
			return;
	end
	
	local iItems = 1;	
	for item, itemData in DKP_ROLL_PLAYERS[CurrentPlayer]['Items'] do
			table.insert(SortIndex, iItems);
			table.insert(arrayItems, item);
			table.insert(arrayDKP, itemData['cost']);
			table.insert(arrayDate, itemData['date']);
			iItems = iItems + 1;
	end
	FauxScrollFrame_Update(DKPM_CPDetailedPlayerItemsScroll, table.getn(SortIndex), 7, 18);
	
	if (DKPM_ColumnSort.PlayerItemList == "itemname") then
			table.sort(SortIndex, function(a,b) return arrayItems[a]>arrayItems[b] end)
	elseif (DKPM_ColumnSort.PlayerItemList == "itemname_dec") then	
			table.sort(SortIndex, function(b,a) return arrayItems[a]>arrayItems[b] end)
	elseif (DKPM_ColumnSort.PlayerItemList == "dkp") then
			table.sort(SortIndex, function(a,b) return arrayDKP[a]>arrayDKP[b] end)	
	elseif (DKPM_ColumnSort.PlayerItemList == "dkp_dec") then
			table.sort(SortIndex, function(b,a) return arrayDKP[a]>arrayDKP[b] end)	
	elseif (DKPM_ColumnSort.PlayerItemList == "date") then
			table.sort(SortIndex, function(a,b) return arrayDate[a]>arrayDate[b] end)	
	elseif (DKPM_ColumnSort.PlayerItemList == "date_dec") then
			table.sort(SortIndex, function(b,a) return arrayDate[a]>arrayDate[b] end)	
	end	
	
	for line=1,7 do 
			lineplusoffset = line + FauxScrollFrame_GetOffset(DKPM_CPDetailedPlayerItemsScroll);
			if (lineplusoffset <= table.getn(SortIndex)) then
					getglobal("DKPM_CPDetailedPlayerItemsRow"..line):Show();
								
					local itemcolor = DKPM_GetItemColor(arrayItems[SortIndex[lineplusoffset]]);			
					
					if (itemcolor ~= nil) then
							getglobal("DKPM_CPDetailedPlayerItemsRow"..line.."Item"):SetText("|c".. itemcolor .. arrayItems[SortIndex[lineplusoffset]]);
					else
							getglobal("DKPM_CPDetailedPlayerItemsRow"..line.."Item"):SetText(arrayItems[SortIndex[lineplusoffset]]);
					end											
					getglobal("DKPM_CPDetailedPlayerItemsRow"..line.."ItemPlain"):SetText(arrayItems[SortIndex[lineplusoffset]]);
					--getglobal("DKPM_CPDetailedPlayerItemsRow"..line.."Item"):SetText(arrayItems[SortIndex[lineplusoffset]]);
					getglobal("DKPM_CPDetailedPlayerItemsRow"..line.."DKP"):SetText(format(DKPM_Options.percision, arrayDKP[SortIndex[lineplusoffset]]));
					getglobal("DKPM_CPDetailedPlayerItemsRow"..line.."LootedOn"):SetText(arrayDate[SortIndex[lineplusoffset]]);	
			else
					getglobal("DKPM_CPDetailedPlayerItemsRow"..line):Hide();
			end
	end
	
	--DEFAULT_CHAT_FRAME:AddMessage("done");
end


function DKPM_PlayerRaidList_Update()
	local line = 0;

	
	local SortIndex = {};
	local arrayRaidID = {};
	local arrayRaidName = {};
	local arrayRaidWorth = {};
	local arrayRaidDate = {};	

	local iPlayerRaids = 1;			
	for raidTimeStamp, raidData in DKP_ROLL_RAIDS do
			for index, attendPlayer in raidData['raid_attendees'] do
					if (attendPlayer == CurrentPlayer) then
							
							table.insert(SortIndex, iPlayerRaids);
							table.insert(arrayRaidID, raidTimeStamp);				
							table.insert(arrayRaidName, raidData['raid_name']);				
							table.insert(arrayRaidWorth, raidData['raid_worth']);
							table.insert(arrayRaidDate, raidData['raid_date']);							
							
							iPlayerRaids = iPlayerRaids + 1;
					end
			end
	end	
	FauxScrollFrame_Update(DKPM_CPDetailedPlayerRaidScroll, table.getn(SortIndex), 11, 18);			

	if (DKPM_ColumnSort.PlayerRaidList == "raidname") then
			table.sort(SortIndex, function(a,b) return arrayRaidName[a]>arrayRaidName[b] end)
	elseif (DKPM_ColumnSort.PlayerRaidList == "raidname_dec") then	
			table.sort(SortIndex, function(b,a) return arrayRaidName[a]>arrayRaidName[b] end)
	elseif (DKPM_ColumnSort.PlayerRaidList == "dkp") then
			table.sort(SortIndex, function(a,b) return arrayRaidWorth[a]>arrayRaidWorth[b] end)
	elseif (DKPM_ColumnSort.PlayerRaidList == "dkp_dec") then	
			table.sort(SortIndex, function(b,a) return arrayRaidWorth[a]>arrayRaidWorth[b] end)
	elseif (DKPM_ColumnSort.PlayerRaidList == "date") then
			table.sort(SortIndex, function(a,b) return arrayRaidID[a]>arrayRaidID[b] end)
	elseif (DKPM_ColumnSort.PlayerRaidList == "date_dec") then	
			table.sort(SortIndex, function(b,a) return arrayRaidID[a]>arrayRaidID[b] end)
	end
			
	for line=1,11 do 
			lineplusoffset = line + FauxScrollFrame_GetOffset(DKPM_CPDetailedPlayerRaidScroll);
			if (lineplusoffset <= table.getn(SortIndex)) then
					getglobal("DKPM_CPDetailedPlayerRaidRow"..line):Show();
								
					getglobal("DKPM_CPDetailedPlayerRaidRow"..line.."RaidID"):SetText(arrayRaidID[SortIndex[lineplusoffset]]);
					getglobal("DKPM_CPDetailedPlayerRaidRow"..line.."RaidName"):SetText(arrayRaidName[SortIndex[lineplusoffset]]);
					getglobal("DKPM_CPDetailedPlayerRaidRow"..line.."Value"):SetText(format(DKPM_Options.percision, arrayRaidWorth[SortIndex[lineplusoffset]]));
					getglobal("DKPM_CPDetailedPlayerRaidRow"..line.."Date"):SetText(arrayRaidDate[SortIndex[lineplusoffset]]);
			else
					getglobal("DKPM_CPDetailedPlayerRaidRow"..line):Hide();
			end
	end
end

function DKPM_GetItemLink (checkItemName) 

		local ItemName, ItemValues;
		local ItemFound = false;
		
		local IMitem;
		local ItemColor, ItemCode;
		
		local ItemText = "";
				

		if (ISync ~= nil) then
				
				if ((DKPItemCache[checkItemName] ~= nil) and (DKPItemCache[checkItemName] ~= -1)) then														
						return DKPItemCache[checkItemName]..":0:0:0";
				else
						return nil;
				end			
								
		-- ItemMatrix Code
		elseif (IMDB ~= nil) then
				--DEFAULT_CHAT_FRAME:AddMessage("ItemMatrix Found");
		
				-- Sort out IM's garble
				-- "ff0070dd14624:0:0:074",
				-- ffffffff6265:0:0:46458008
				local pattern_im_item = "(.+)(.+)";						
				
				for ItemColor, ItemCode in string.gfind(IMDB[checkItemName], pattern_im_item) do															
						return ItemCode;
				end
				
		-- LootLink Code
		elseif (ItemLinks ~= nil) then
				if (ItemLinks[checkItemName] ~= nil) then
						return ItemLinks[checkItemName]['i'];			
				end			
		end
		
		return nil;
end

function DKPM_GetItemColor (checkItemName) 

		local ItemName, ItemValues;
		local ItemFound = false;
		
		local IMitem;
		local ItemColor, ItemCode;
		
		local ItemText = "";				

		-- GetData		
		if (ISync ~= nil) then
				
				if(not ISyncDB_Names) then return nil; end
				
				-- Since ItemSync totally fucked their database up we have to cache our own items so it isn't slow as hell
				if (DKPItemCache['date'] ~= date("%m/%d/%y")) then
						DKPItemCache['date'] = date("%m/%d/%y");
						-- check for updates once a day

						local itemList = {};
						for playersname, playerdata in DKP_ROLL_PLAYERS do
								if (DKP_ROLL_PLAYERS[playersname]['Items'] ~= nil) then					
									for itemName, itemData in DKP_ROLL_PLAYERS[playersname]['Items'] do									
											table.insert(itemList, itemName);		
									end
								end
						end						
						
						for index, itemname in itemList do	
								if (DKPItemCache[checkItemName] == nil) then
										for index, value in ISyncDB_Names do	
												if(string.lower(value) == string.lower(itemname)) then
														DKPItemCache[checkItemName] = index;
												end
										end
								end
						end												
				end
									
				if (DKPItemCache[checkItemName] ~= nil) then														
						local sName, sLink, iQuality, iLevel, sType, sSubType, iCount = GetItemInfo("item:".. DKPItemCache[checkItemName]);
						local QL_Colors = { "ff9d9d9d", "ffffffff", "ff1eff00", "ff0070dd", "ffa335ee", "ffff8000", "ffffcc9d"};	
						if (iQuality ~= nil) then
								ItemColor = QL_Colors[iQuality + 1];		
						else
								return nil;
						end								
						return ItemColor;										
				else
						return nil;
				end					
		
		-- ItemMatrix Code	
		elseif (IMDB ~= nil) then
				--DEFAULT_CHAT_FRAME:AddMessage("ItemMatrix Found");
		
				-- Sort out IM's garble
				-- "ff0070dd14624:0:0:074",
				-- ffffffff6265:0:0:46458008
				local pattern_item = "(.+)(.+)";						
				
				for ItemColor, ItemCode in string.gfind(IMDB[checkItemName], pattern_item) do															
						return ItemColor;
				end
				
		-- LootLink Code		
		elseif (ItemLinks ~= nil) then
				if (ItemLinks[checkItemName] ~= nil) then
						return ItemLinks[checkItemName]['c'];			
				end			
		end
		
		return nil;
end

function DKPM_GetItemLinkText( itemName )
		
		return itemName;

end

-- ############################################################################################
-- ## Miscilanious Functions 

--[[
Extract key/value from message.
]]--
function GetArgs(message, separator)

	-- Declare 'args' variable.
	local args = {};

	-- Declare 'i' integer.
	i = 0;

	-- Search for seperators in the string and return
	-- the separated data.
	for value in string.gfind(message, "[^"..separator.."]+") do
		i = i + 1;
		args[i] = value;
	end -- end for

	-- Submit the filtered data.
	return args;
end -- end GetArgs()

function CapName (name)

		return (strupper(strsub(name,1,1))..strsub(name,2));		

end
