-- Declard color codes for console messages
local RED     = "|cffff0000";
local GREEN   = "|cff00ff00";
local BLUE    = "|cff0000ff";
local MAGENTA = "|cffff00ff";
local YELLOW  = "|cffffff00";
local CYAN    = "|cff00ffff";
local WHITE   = "|cffffffff";
local PURPLE = "|cffff00ff";

-- local Function Prototypes


-- Declare globals
DKPMU_Options = {};
DKPMU_Options.channel = "dkpmatrix";
DKPMU_Options.broadcast = true;
DKPMU_Options.active = true;
DKPMU_Options.autosync = true;
DKPMU_Options.dbactive = {};

DKPMU_State = {};
DKPMU_State.mainclient = false;
DKPMU_State.announcing = false;
DKPMU_State.tx_player = false;
DKPMU_State.tx_raid = false
DKPMU_State.tx_chars = 0;

DKPMU_State.rx = false;
DKPMU_State.rx_chars = 0;

DKPMU_State.cur_db = 0;
DKPMU_State.cur_db_size = 0;
DKPMU_State.cur_db_time = 0;
DKPMU_State.players = 0;
DKPMU_State.raids = 0;

DKPMU_State.ourclient = 0; -- our tx client #
DKPMU_State.clients = 0;	-- client assisting in tx

DKPMU_State.aclients_list = {};
DKPMU_State.rclients_list = {};
DKPMU_State.txClientData = {};

DKPMU_State.rclients = {};     -- requesting clients
DKPMU_State.tx_members = false; -- transmitting members
DKPMU_State.tx_raids = false; -- transmitting raids
DKPMU_State.div_members = 0;
DKPMU_State.div_raids = 0;
DKPMU_State.offset_members = 0;
DKPMU_State.offset_raids = 0
DKPMU_State.tx_players_datastr = "";

DKPMU_State.countnegotiate = 10;
DKPMU_State.negotiating = false;

local DKPM_UpdateInterval = 3.0; -- How often the OnUpdate code will run (in seconds)
local DKPM_TxInterval = 0.3; -- How often the OnUpdate code will run (in seconds)

local time_lastTx = 0;
local avgTxSpeed = 0;
local time = 0;

local debug = false;
local old_SendChatMessage;


function DKPMU_OnLoad ()

		-- Load DKP_Data addon if not already				
		--local loaded, reason = LoadAddOn("Sea");		
		--DEFAULT_CHAT_FRAME:AddMessage(loaded);	

		this:RegisterEvent("CHAT_MSG_CHANNEL");
		this:RegisterEvent("CHAT_MSG_CHANNEL_JOIN");
		this:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");
		this:RegisterEvent("CHAT_MSG_CHANNEL_LEAVE");
		this:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE_USER");
		
		DKPMU_isDbCurrent = {};
		DKPMU_DbBroadcast = {};
		for iDB = 0, 4 do
				if (DKP_DB[iDB] ~= nil) then
						DKPMU_isDbCurrent[iDB] = true;
						DKPMU_DbBroadcast[iDB] = false;	
						DKPMU_State.aclients_list[iDB] = {};															
						table.insert(DKPMU_State.aclients_list[iDB], string.lower(UnitName("player")));								
						DKP_DB[iDB]['chars'] = strlen(Sea.string.objectToString(DKP_DB[iDB]['playerdata'])) + strlen(Sea.string.objectToString(DKP_DB[iDB]['raiddata']));
				end
		end			
		
		old_SendChatMessage = SendChatMessage;
		SendChatMessage = DKPM_SendChatMessage;		
		
		local id, name = GetChannelName(DKPMU_Options.channel);	
		SendChatMessage("DB_REQ_ALL", "CHANNEL", nil, id);
end

function DKPM_SendChatMessage(...)	
	
	if (time_lastTx ~= 0) then
			avgTxSpeed = (avgTxSpeed+(time - time_lastTx))/2;
			if (debug) then DEFAULT_CHAT_FRAME:AddMessage("Average Transfer Speed = ".. avgTxSpeed); end
	end
	time_lastTx = time;
			
	return old_SendChatMessage(arg[1],arg[2],arg[3],arg[4]);
end


function DKPM_CPSyncDBList_OnLoad()	
								
	for line=0,4 do 										
			if ((DKP_DB[line] ~= nil) and (DKP_DB[line]['dbname'] ~= nil)) then									
					
					local iPlayers = 0;
					for playerName, playerData in DKP_DB[line]['playerdata'] do				
							iPlayers = iPlayers + 1;
					end			
										
					local iRaids = 0;
					for raidName, raidData in DKP_DB[line]['raiddata'] do						
							iRaids = iRaids + 1;
					end					
					
					local est_time = 0;
					if (DKP_DB[line]['chars'] == nil) then
							local playerDataString = Sea.string.objectToString(DKP_DB[line]['playerdata']);					
							local raidDataString = Sea.string.objectToString(DKP_DB[line]['raiddata']);						
					
							est_time = (((strlen(playerDataString) + strlen(raidDataString))/255)*DKPM_TxInterval)/60;
							DKP_DB[line]['chars'] = strlen(playerDataString) + strlen(raidDataString);
					else 
							est_time = ((DKP_DB[line]['chars']/255)*DKPM_TxInterval)/60;
					end
					local est_time_min = format("%0.0f",math.floor(est_time));
					local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
					if (est_time <= 1) then
							est_time = est_time_sec .. " Sec";
					else 
							est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
					end 										
					
					getglobal("DKPM_CPSyncDBListRow"..line.."DBName"):SetText(GREEN.. DKP_DB[line]['dbname']);
					getglobal("DKPM_CPSyncDBListRow"..line.."Users"):SetText(GREEN .. iPlayers);
					getglobal("DKPM_CPSyncDBListRow"..line.."Raids"):SetText(GREEN .. iRaids);
					getglobal("DKPM_CPSyncDBListRow"..line.."UpToDate"):SetText(GREEN .. "Yes");
					getglobal("DKPM_CPSyncDBListRow"..line.."AC"):SetText(GREEN .. "1");					
					getglobal("DKPM_CPSyncDBListRow"..line.."RC"):SetText(GREEN .. "0");	
					getglobal("DKPM_CPSyncDBListRow"..line.."Status"):SetMinMaxValues(0,100);
					getglobal("DKPM_CPSyncDBListRow"..line.."Status"):SetValue(0);
					getglobal("DKPM_CPSyncDBListRow"..line.."StatusLeftText"):SetText(GREEN .. "Ready to Sync");	
					getglobal("DKPM_CPSyncDBListRow"..line.."StatusRightText"):SetText(GREEN .. est_time);	
			else
					getglobal("DKPM_CPSyncDBListRow"..line.."DBName"):SetText("No Database Loaded");
					getglobal("DKPM_CPSyncDBListRow"..line.."Users"):SetText("--");
					getglobal("DKPM_CPSyncDBListRow"..line.."Raids"):SetText("--");
					getglobal("DKPM_CPSyncDBListRow"..line.."UpToDate"):SetText("--");
					getglobal("DKPM_CPSyncDBListRow"..line.."AC"):SetText("--");					
					getglobal("DKPM_CPSyncDBListRow"..line.."RC"):SetText("--");	
					getglobal("DKPM_CPSyncDBListRow"..line.."Status"):SetMinMaxValues(0,100);
					getglobal("DKPM_CPSyncDBListRow"..line.."Status"):SetValue(0);
					getglobal("DKPM_CPSyncDBListRow"..line.."StatusLeftText"):SetText("--");	
					getglobal("DKPM_CPSyncDBListRow"..line.."StatusRightText"):SetText("--");						
					getglobal("DKPM_CPSyncDBListRow"..line.."Status"):SetStatusBarColor( 0, 0, 0, 1 );
			end
								
																
			--getglobal("DKPM_IHItemListRow"..line.."DKP"):SetText(format(DKPM_Options.percision, arrayDKP[SortIndex[lineplusoffset]]));
			--getglobal("DKPM_IHItemListRow"..line.."LootedBy"):SetText(CapName(arrayLootedBy[SortIndex[lineplusoffset]]));	

	end
end

-- ###################################################################
-- # DKPU (DKP Syncronization Functions
-- ###################################################################

function DKPMU_CPSyncDSetActiveSync_OnClick()
		
		local checked = getglobal(this:GetName()):GetChecked();			
		if (checked == 1) then
				--DEFAULT_CHAT_FRAME:AddMessage("checked:"..checked.." ID"..this:GetID());		
				DKPMU_Options.dbactive[this.DBid] = true;
		else 
				DKPMU_Options.dbactive[this.DBid] = false;
		end
		
end

-- Functions Section
function DKPMU_OnUpdate(elapsed)
	-- max brodcast size: 255
	-- 
	time = time + elapsed;
	local id, name = GetChannelName(DKPMU_Options.channel);	
	
	DKPMU_State.countnegotiate = DKPMU_State.countnegotiate - elapsed;
  this.TimeSinceLastUpdate = this.TimeSinceLastUpdate + elapsed; 	
  this.TimeSinceLastTx = this.TimeSinceLastTx + elapsed; 	
  
  if (not DKPMU_Options.active) then return; end
	--DEFAULT_CHAT_FRAME:AddMessage(this.TimeSinceLastUpdate);	
			
	-- ###############################
	-- Initiate Data Transfer
	-- ###############################
	if ((DKPMU_State.tx) 
	and (DKPMU_State.negotiating) 
	and (not DKPMU_State.tx_player) 
	and (not DKPMU_State.tx_raid) 
	and (DKPMU_State.countnegotiate < 0)
	and (DKPMU_State.ourclient ~= nil)) then
			DKPMU_State.negotiating = false;
			DKPMU_State.tx_player = true;
			DKPMU_State.tx_raid = true;		
			DKPMU_State.tx_players_datastr = "";	
			DKPMU_State.tx_raids_datastr = "";
			
			local clientnum = 2;
			DKPMU_State.clients = table.getn(DKPMU_State.aclients_list[iDB]);	
			if (DKPMU_State.mainclient) then
					for index, client in DKPMU_State.aclients_list[iDB] do
							if (client ~= string.lower(UnitName("player"))) then 
									if (debug) then DEFAULT_CHAT_FRAME:AddMessage(PURPLE .. "DICT_CLIENT:".. clientnum ..":".. index ..":".. table.getn(DKPMU_State.aclients_list[iDB])); end
									SendChatMessage("DICT_CLIENT:".. client ..":".. clientnum ..":".. table.getn(DKPMU_State.aclients_list[iDB]), "CHANNEL", nil, id);
									clientnum = clientnum + 1;
							else 
									--DEFAULT_CHAT_FRAME:AddMessage(PURPLE .. "DICT_CLIENT:".. client ..":".. index ..":".. table.getn(DKPMU_State.aclients_list[iDB])); 
							end					
					end	
					--DKPMU_State.clients = 1;	
					--DKPMU_State.ourclient = 1;
			end			
			--return nil;
			
			if (debug) then DEFAULT_CHAT_FRAME:AddMessage(CYAN .. "Starting data broadcast, we are client #:"..DKPMU_State.ourclient); end
			
			DKPMU_State.div_members = math.floor(DKPMU_State.players / table.getn(DKPMU_State.aclients_list[DKPMU_State.cur_db]));
			DKPMU_State.div_raids = math.floor(DKPMU_State.raids / table.getn(DKPMU_State.aclients_list[DKPMU_State.cur_db]));
			DKPMU_State.offset_members = (DKPMU_State.ourclient-1) * DKPMU_State.div_members;
			DKPMU_State.offset_raids = (DKPMU_State.ourclient-1) * DKPMU_State.div_raids;				
			
			if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. "members:".. DKPMU_State.players .." raids:".. DKPMU_State.raids); end
			if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. "div_mem:".. DKPMU_State.div_members.." div_raids:".. DKPMU_State.div_raids .." offset_mem:".. DKPMU_State.offset_members .." offset_raids:".. DKPMU_State.offset_raids); end
			
			local tmp_data_sort = {};
			for playerName, playerData in DKP_DB[DKPMU_State.cur_db]['playerdata'] do				
					table.insert(tmp_data_sort, playerName);
			end			
			table.sort(tmp_data_sort, function(a,b) return a<b end)

			
			local iPlayers = 0;
			local playerDataArray = {};
			for index, playerName in tmp_data_sort do				
					playerData = DKP_DB[DKPMU_State.cur_db]['playerdata'][playerName];
					if ( ((iPlayers >= DKPMU_State.offset_members) and
							 (iPlayers < (DKPMU_State.offset_members+DKPMU_State.div_members)))
							 or ( (DKPMU_State.clients == DKPMU_State.ourclient) and
							      (iPlayers >= DKPMU_State.offset_members)) ) then
																	
							playerDataArray[playerName] = playerData;																
					end
					iPlayers = iPlayers + 1;
			end			
			DKPMU_State.tx_players_datastr = Sea.string.objectToString(playerDataArray);
			--local test = Sea.string.stringToObject(DKPMU_State.tx_players_datastr);			
			--DKPM_Options[msgFrom]['players'] = DKPMU_State.tx_players_datastr;
			
			local tmp_data_sort = {};
			for raidName, raidData in DKP_DB[DKPMU_State.cur_db]['raiddata'] do
					table.insert(tmp_data_sort, raidName);
			end
			table.sort(tmp_data_sort, function(a,b) return a<b end)
			
			local iRaids = 0;
			local raidDataArray = {};
			for index, raidName in tmp_data_sort do				
					raidData = DKP_DB[DKPMU_State.cur_db]['raiddata'][raidName];
					if ( ((iRaids >= DKPMU_State.offset_raids) and
							 (iRaids < (DKPMU_State.offset_raids+DKPMU_State.div_raids)))
							 or ( (DKPMU_State.clients == DKPMU_State.ourclient) and
							      (iRaids >= DKPMU_State.offset_raids)) ) then
							
							raidDataArray[raidName] = raidData;																								
					end										
					iRaids = iRaids + 1;
			end					
			
			DKPMU_State.tx_raids_datastr = Sea.string.objectToString(raidDataArray);
			--local test = Sea.string.stringToObject(DKPMU_State.tx_players_datastr);
			--DKPM_Options[msgFrom]['raids'] = DKPMU_State.tx_raids_datastr;
			
			SendChatMessage("DB_START_BC:".. iDB ..":".. dbdate ..":".. strlen(DKPMU_State.tx_players_datastr) ..":".. strlen(DKPMU_State.tx_raids_datastr), "CHANNEL", nil, id);
			
			DKPMU_State.tx_chars = 0;			
			
			if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. "members_tx len:".. strlen(DKPMU_State.tx_players_datastr) .."raids_tx len:".. strlen(DKPMU_State.tx_raids_datastr)); end
			DKPMU_State.tx_offset = 1;
			
  elseif ((this.TimeSinceLastUpdate > DKPM_UpdateInterval) and (not DKPMU_State.negotiating) and (not DKPMU_State.rx) and (not DKPMU_State.tx_player) and (not DKPMU_State.tx_raid)) then
	-- ###############################
	-- Announce Database Timestamp
	-- ###############################

		this.TimeSinceLastUpdate = 0;			
		if (DKPMU_Options.active) then
				-- Scheduled broadcasting of database versions
				--DKPMU_PROTO_BC_DB_VER();
				local id, name = GetChannelName(DKPMU_Options.channel);	
			  if (id ~= nil) then	  	  
			  		for iDB = 0, table.getn(DKP_DB) do
			  				if (DKPMU_DbBroadcast[iDB] == false) then
			  					
			  						DKPM_PROTO_DB_VER(iDB);
						  			DKPMU_DbBroadcast[iDB] = true;				  			
						  			return true;
				  			end
		  			end
		  	else
		  			return nil;
		  	end					
		end
    
  elseif ((this.TimeSinceLastTx > DKPM_TxInterval) and (DKPMU_State.tx_player or DKPMU_State.tx_raid)) then
	-- ###############################
	-- Main Data Transfer
	-- ###############################
	
		if ((avgTxSpeed+(time-time_lastTx)) < DKPM_TxInterval) then		
			-- Throttle Bandwidth Out			
			-- If other addons have sent data within the last time we have updated, wait a bit			
			return;
		else
			--DEFAULT_CHAT_FRAME:AddMessage("Speed good ="..(avgTxSpeed+(time-time_lastTx)));
		end
			
		if (DKPMU_State.tx_player) then
				SendChatMessage(strsub(DKPMU_State.tx_players_datastr, DKPMU_State.tx_offset, DKPMU_State.tx_offset+255) , "CHANNEL", nil, id); 
				DKPMU_State.tx_offset = DKPMU_State.tx_offset + 255;     	 	 	 
				DKPMU_State.tx_chars = DKPMU_State.tx_chars + 255;
				
				if (DKPMU_State.tx_offset > strlen(DKPMU_State.tx_players_datastr)) then
						if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. "Done transmitting members!"); end
						DKPMU_State.tx_player = false; -- if we distributed all our data, we're done
						SendChatMessage("DB_END_BC:P", "CHANNEL", nil, id);
						DKPMU_State.tx_offset = 1;
				end
		end

		if (DKPMU_State.tx_raid and (not DKPMU_State.tx_player)) then
				SendChatMessage(strsub(DKPMU_State.tx_raids_datastr, DKPMU_State.tx_offset, DKPMU_State.tx_offset+255) , "CHANNEL", nil, id); 
				DKPMU_State.tx_offset = DKPMU_State.tx_offset + 255;     	 	 	 
				DKPMU_State.tx_chars = DKPMU_State.tx_chars + 255;
				
				if (DKPMU_State.tx_offset > strlen(DKPMU_State.tx_raids_datastr)) then
						if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. "Done transmitting raids!"); end
						DKPMU_State.tx_raid = false; -- if we distributed all our data, we're done
						DKPMU_State.tx = false; -- done transmititng						
						SendChatMessage("DB_END_BC:R", "CHANNEL", nil, id);																		
						DKPMU_FlushRCClients(); -- Finished transfer, no more receiving clientsa
				end
		end		
		
		if (DKPMU_State.tx_raid or DKPMU_State.tx_player) then
				-- Update GUI with timeleft
				local tx_size = strlen(DKPMU_State.tx_players_datastr) + strlen(DKPMU_State.tx_raids_datastr);
				getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."Status"):SetValue( (DKPMU_State.tx_chars/tx_size)*100 );		
				local percent = format("%0.1f",(DKPMU_State.tx_chars/tx_size)*100);										
				--DEFAULT_CHAT_FRAME:AddMessage("percent = ".. percent);
				getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusLeftText"):SetText("Transmitting Data (".. percent .."%)");										
				
				local est_time = (((tx_size - DKPMU_State.tx_chars)/255)*DKPM_TxInterval)/60;
				local est_time_min = format("%0.0f",math.floor(est_time));
				local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
				if (est_time <= 1) then
						est_time = est_time_sec .. " Sec";
				else 
						est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
				end 
				getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusRightText"):SetText(GREEN .. est_time);			
		else 
				-- Update GUI to indicate we're finished
				
				DKPMU_FlushBroadcast();
				local est_time = ((DKP_DB[DKPMU_State.cur_db]['chars']/255)*DKPM_TxInterval)/60;
				local est_time_min = format("%0.0f",math.floor(est_time));
				local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
				if (est_time <= 1) then
						est_time = est_time_sec .. " Sec";
				else 
						est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
				end 
												
				getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."Status"):SetValue(0);
				getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusLeftText"):SetText(GREEN .. "Ready to Sync");	
				getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusRightText"):SetText(GREEN .. est_time);				
		end
		
		this.TimeSinceLastTx = 0;
  end  
  
end


function DKPMU_OnEvent(event)	
		--DKPMU_AddACClient(string.lower(UnitName("player")), iDB);

		if (event == "CHAT_MSG_CHANNEL_LEAVE") then
				--DEFAULT_CHAT_FRAME:AddMessage(event..":"..arg1..":"..arg9..":"..arg2);
				for iDB = 0, 4 do						
						if (DKP_DB[iDB] ~= nil) then
								DKPMU_RemoveACClient(string.lower(arg2), iDB);
								getglobal("DKPM_CPSyncDBListRow"..iDB.."AC"):SetText(GREEN .. table.getn(DKPMU_State.aclients_list[iDB]));
						end
				end
				
				return;
		end
		if (event == "CHAT_MSG_CHANNEL_JOIN") then
				if (debug) then DEFAULT_CHAT_FRAME:AddMessage(event..":"..arg1); end
				return;
		end
		if (event == "CHAT_MSG_CHANNEL_NOTICE") then
				if (arg1 == "YOU_JOINED") then
					--AddChatWindowChannel(DEFAULT_CHAT_FRAME:GetID(), arg9) 
				elseif (arg1 == "YOU_LEFT") then					
						for iDB = 0, 4 do								
								if (DKP_DB[iDB] ~= nil) then
										DKPMU_State.aclients_list[iDB] = {};
										DKPMU_AddACClient(string.lower(UnitName("player")), iDB);										
								end
						end					
				end				
				if (debug) then DEFAULT_CHAT_FRAME:AddMessage(event..":"..arg1..":"..arg9..":"..arg2..";"..arg3); end
				return;
		end
		if (event == "CHAT_MSG_CHANNEL_NOTICE_USER") then
				if (arg1 == "YOU_JOINED") then
					--AddChatWindowChannel(DEFAULT_CHAT_FRAME:GetID(), arg9) 
				end
				if (debug) then DEFAULT_CHAT_FRAME:AddMessage(event..":"..arg1..":"..arg9..":"..arg2..";"..arg3);end
				return;
		end
	
	if (arg9 ~= DKPMU_Options.channel) then return; end

		local id, name = GetChannelName(DKPMU_Options.channel);	
		if ((event == "CHAT_MSG_CHANNEL") and (arg9 == DKPMU_Options.channel) and (string.lower(arg2) ~= string.lower(UnitName("player"))) ) then				
				cmdArgs = GetArgs(arg1, ":");				
				msgFrom = string.lower(arg2);	
				
				--DEFAULT_CHAT_FRAME:AddMessage(table.getn(cmdArgs));
				
				if (cmdArgs[1] == "DB_VER") then
				-- ###############################
				-- Receive Database Timestamp
				-- ###############################					
				-- DB_DATE: Used to broadcast your current database timestamp, other clients that are below
				-- this timestamp will request to sync'ed up with this database since theirs is lower.
				-- arg2 = # of the database 
				-- arg3 = database name
				-- arg4 = database timestamp
						
						iDB = tonumber(cmdArgs[2]);
						dbname = cmdArgs[3];
						dbdate = tonumber(cmdArgs[4]);
						dbplayers = tonumber(cmdArgs[5]);
						dbraids = tonumber(cmdArgs[6]);
						dbchars = tonumber(cmdArgs[7]);
						
						if ((DKPMU_State.rx) or (DKPMU_State.tx)) then return; end
						
						if (((DKP_DB[iDB] == nil) or (DKP_DB[iDB]['dbname'] ~= dbname) or (DKP_DB[iDB]['dbdate'] < dbdate))
					  and (not DKPMU_State.rx)) then
						-- If this database does not exist or is not up-to-date .. request this database be broadcasted 
						
								SendChatMessage("DB_REQ:".. iDB ..":".. dbdate ..":".. msgFrom, "CHANNEL", nil, id);
								DKP_DB_TEMP[iDB] = {};
								DKP_DB_TEMP[iDB]['dbname'] = dbname;
								DKP_DB_TEMP[iDB]['dbdate'] = dbdate;
								DKP_DB_TEMP[iDB]['complete'] = false;																
								
								DKPMU_State.mainclient = false;
								DKPMU_State.rx = true;   -- since someone says they have new data for us, we want to receive it
								DKPMU_State.rx_chars = 0; -- # of chars received
								DKPMU_State.tx_player = false;		
								DKPMU_State.tx_raid = false;
								DKPMU_State.negotiating = false;		
								DKPMU_State.cur_db = iDB;		
								DKPMU_State.cur_db_size = dbchars;
								DKPMU_State.cur_db_time = dbdate;		
								DKPMU_State.players = dbplayers;
								DKPMU_State.raids = dbraids;								
								
								--DKPMU_FlushACClientsDB(iDB);
								--DKPMU_FlushRCClientsDB(iDB);								
								DKPMU_AddRCClient(string.lower(UnitName("player")), iDB);
								
								DKPMU_AddACClient(msgFrom, iDB);
								DKPMU_RemoveACClient(string.lower(UnitName("player")), iDB);
								

								DKPMU_State.rx_client_playerdata = {};			
								DKPMU_State.rx_client_raiddata = {};
								DKPMU_State.rx_data = {};
								
								-- Update GUI that database is out-of-date and we are requesting the new one
								getglobal("DKPM_CPSyncDBListRow"..iDB.."DBName"):SetText(RED .. dbname);
								getglobal("DKPM_CPSyncDBListRow"..iDB.."Users"):SetText(RED .. dbplayers);
								getglobal("DKPM_CPSyncDBListRow"..iDB.."Raids"):SetText(RED .. dbraids);
								getglobal("DKPM_CPSyncDBListRow"..iDB.."UpToDate"):SetText(RED .. "No");
								getglobal("DKPM_CPSyncDBListRow"..iDB.."StatusLeftText"):SetText(GREEN .. "Requesting Data");	
								local est_time = ((dbchars/255)*DKPM_TxInterval)/60;
								--local est_time = (((DKPMU_State.cur_db_size - DKPMU_State.rx_chars)/255)*DKPM_TxInterval)/60;
								local est_time_min = format("%0.0f",math.floor(est_time));
								local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
								if (est_time <= 1) then
										est_time = est_time_sec .. " Sec";
								else 
										est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
								end 								
								getglobal("DKPM_CPSyncDBListRow"..iDB.."StatusRightText"):SetText(RED .. est_time);									
								getglobal("DKPM_CPSyncDBListRow"..iDB.."Status"):SetStatusBarColor( 1, 0, 0, 1 );
								
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED.. "DB Request, ".. msgFrom .." has newer database for ".. dbname); end
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED.. "Receiving mode ON"); end
																
						elseif ((DKP_DB[iDB] ~= nil) and (DKP_DB[iDB]['dbname'] == dbname) and (DKP_DB[iDB]['dbdate'] > dbdate)) then
						-- If we have a more up-to-date database than the version being broadcast by a different client, say that ours is more up to date													
								
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. "Announcing we have a more up to date database than ".. msgFrom .."!"); end
								DKPM_PROTO_DB_VER(iDB);				  				
						elseif ((DKP_DB[iDB] ~= nil) and (DKP_DB[iDB]['dbname'] == dbname) and (DKP_DB[iDB]['dbdate'] == dbdate)) then
								-- Add client to assisting clients for this db
								DKPMU_AddACClient(msgFrom, iDB);								
																
								--getglobal("DKPM_CPSyncDBListRow"..iDB.."RC"):SetText(GREEN .. DKPMU_State.rclients[iDB]);								
						elseif ((DKP_DB[iDB] == nil) or (DKP_DB[iDB]['dbname'] ~= dbname) or (DKP_DB[iDB]['dbdate'] ~= dbdate)) then
								-- delete user if db they are announcing is != ours
								DKPMU_RemoveACClient(msgFrom, iDB);
						end
						--DEFAULT_CHAT_FRAME:AddMessage(RED .. "DBDATE");
				elseif ((cmdArgs[1] == "DB_REQ") and (not DKPMU_State.rx)) then
				-- ###############################
				-- Receive Database Request
				-- ###############################					
				-- DB_REQ: A client will send DB_REQ when a database with a higher timestamp is posted than their own database.
				-- arg2 = database #				
				-- arg3 = database timestamp

						iDB = tonumber(cmdArgs[2]);
						dbdate = tonumber(cmdArgs[3]);
						mainclientuser = string.lower(cmdArgs[4]);
						if (debug) then DEFAULT_CHAT_FRAME:AddMessage(DKP_DB[iDB]['dbdate']..":"..dbdate.. " ".. mainclientuser..":"..string.lower(UnitName("player"))); end
						if (    (DKP_DB[iDB] ~= nil) 
								and (DKP_DB[iDB]['dbdate'] == dbdate) 
								and (not DKPMU_State.rx) -- if we are receiving data, we can't accept new requests
								and (not DKPMU_State.tx) -- if we are transmit data, we can't accept new requests
								and (mainclientuser ~= string.lower(UnitName("player"))) ) then
								-- If we have the same database that other clients are requesting, and it's complete, 
								-- announce that we can assist in broadcasting the database
									
								DKPMU_State.mainclient = false; -- since we are assisting, we are not the main client
								DKPMU_State.clients = nil; -- main client will tell us total
								DKPMU_State.ourclient = nil; -- main client will assign us our client #									
								
								iPlayers = 0;
								for playerName, playerData in DKP_DB[iDB]['playerdata'] do
										iPlayers = iPlayers + 1;
								end
								
								iRaids = 0;
								for raidID, raidData in DKP_DB[iDB]['raiddata'] do
										iRaids = iRaids + 1;
								end								
																								
								DKPMU_State.players = iPlayers;
								DKPMU_State.raids = iRaids;		
								DKPMU_State.cur_db = iDB;
								DKPMU_State.tx = true;
								
								DKPMU_State.countnegotiate = 5; -- seconds to count down before data is transmitted, just to make sure every client had a chance to post their db timestamps + requests
								DKPMU_State.negotiating = true;	-- since we are not transmitting data yet, we are still negotiating transfer														
								
								DKPMU_RemoveACClient(msgFrom, iDB); -- Remove this user from assist tables if exists
								DKPMU_AddACClient(mainclientuser, iDB); -- Add master to assisting if not already done so
								DKPMU_AddRCClient(msgFrom, iDB); -- Add to request table																
								
								SendChatMessage("DB_BC_ASSIST:".. iDB .. ":".. dbdate, "CHANNEL", nil, id);																	
								
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "We can help out with ["..dbname.."] database transfer"); end
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "MasterClient:".. mainclientuser); end
																
								
						elseif ((DKP_DB[iDB] ~= nil) 
								and (DKP_DB[iDB]['dbdate'] == dbdate)
								and (mainclientuser == string.lower(UnitName("player"))) 
								and (not DKPMU_State.tx) 
								and (not DKPMU_State.rx)) then
								-- Receive request for OUR database																			
										
										iPlayers = 0;
										for playerName, playerData in DKP_DB[iDB]['playerdata'] do
												iPlayers = iPlayers + 1;
										end
										
										iRaids = 0;
										for raidID, raidData in DKP_DB[iDB]['raiddata'] do
												iRaids = iRaids + 1;
										end								
																										
										DKPMU_State.players = iPlayers;
										DKPMU_State.raids = iRaids;											

										DKPMU_State.mainclient = true; -- since we are assisting, we are not the main client
										DKPMU_State.ourclient = 1;
									
										DKPMU_State.tx = true;
										DKPMU_State.cur_db = iDB;
										DKPMU_State.countnegotiate = 5; -- seconds to count down before data is transmitted, just to make sure every client had a chance to post their db timestamps
										DKPMU_State.negotiating = true;	-- since we are not transmitting data yet, we are still negotiating transfer		
										
										DKPMU_RemoveACClient(msgFrom, iDB); -- Remove this user from assist tables if exists
										DKPMU_AddRCClient(msgFrom, iDB); -- Add to request table										
										
										if (debug) then DEFAULT_CHAT_FRAME:AddMessage(GREEN .. "Client [".. msgFrom .."] requested DB [".. DKP_DB[iDB]['dbname'] .."]"); end
																				
										getglobal("DKPM_CPSyncDBListRow"..iDB.."StatusLeftText"):SetText(BLUE .. "Client Requesting Data");												
						
						elseif (    (DKP_DB[iDB] ~= nil) 
								and (DKP_DB[iDB]['dbdate'] == dbdate) 
								and (not DKPMU_State.rx) -- if we are receiving data, we can't accept new requests
								and (DKPMU_State.tx) ) then
										-- If we have the same database that other clients are requesting, and it's complete, 
										-- announce that we can assist in broadcasting the database																											
																						
										DKPMU_State.tx = true;
										
										DKPMU_State.countnegotiate = 5; -- seconds to count down before data is transmitted, just to make sure every client had a chance to post their db timestamps + requests
										DKPMU_State.negotiating = true;	-- since we are not transmitting data yet, we are still negotiating transfer														
										
										DKPMU_RemoveACClient(msgFrom, iDB); -- Remove this user from assist tables if exists
										DKPMU_AddRCClient(msgFrom, iDB); -- Add to request table
										
										if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. "Adding client ["..msgFrom.."] to requqest list"); end
						elseif (    (DKP_DB[iDB] ~= nil) 
								and (DKP_DB[iDB]['dbdate'] == dbdate) 
								and (mainclientuser == string.lower(UnitName("player")))) then				
										DKPMU_RemoveACClient(msgFrom, iDB);									
										DKPMU_AddRCClient(msgFrom, iDB);		
						end			
				elseif ((cmdArgs[1] == "DICT_CLIENT") and (not DKPMU_State.rx) and (DKPMU_State.tx)) then
						client = cmdArgs[2];
						iclient = tonumber(cmdArgs[3]);
						iclientTotal = tonumber(cmdArgs[4]);
						
						if ( client == string.lower(UnitName("player"))) then					
								DKPMU_State.clients = iclientTotal;	
								DKPMU_State.ourclient = iclient;								
						end
				elseif ((cmdArgs[1] == "DB_REQ_ALL") and (not DKPMU_State.rx) and (not DKPMU_State.tx)) then
						DKPMU_FlushBroadcast();
				elseif (cmdArgs[1] == "DB_BC_ASSIST") then
				-- ###############################
				-- Receive Database Assist
				-- ###############################					
				-- DB_REQ: A client will send DB_BC_ASSIST when they have the most up to date database and they can assist
				-- in data transfer to other clients that need updating
				
				-- arg2 = database #				
				-- arg3 = database timestamp					
						iDB = tonumber(cmdArgs[2]);
						dbdate = tonumber(cmdArgs[3]);
											
						if (    (DKP_DB[iDB] ~= nil) 
								and (DKP_DB[iDB]['dbdate'] == dbdate)
								--and (not DKPMU_State.rx) 
								and ((not DKPMU_State.tx) or DKPMU_State.negotiating) 
								and (msgGrom ~= string.lower(UnitName("player"))) ) then		
									
									if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED .. msgFrom .." added to assisting client data transfer list!"); end
									
									-- Add client to assisting client list for this db
									DKPMU_AddACClient(msgFrom, iDB);
									--getglobal("DKPM_CPSyncDBListRow"..iDB.."AC"):SetText(GREEN .. table.getn(DKPMU_State.aclients_list[iDB]));
						elseif ( ((not DKPMU_State.tx) or DKPMU_State.negotiating) 
								  and (msgGrom ~= string.lower(UnitName("player"))) ) then	
								  DKPMU_AddACClient(msgFrom, iDB);	
						end		
				elseif ((cmdArgs[1] == "DB_START_BC") and DKPMU_State.rx) then
					-- ###############################
					-- Client Indicating they are starting to transmit data
					-- ###############################					
						local iDB = tonumber(cmdArgs[2]);
						local dbdate = tonumber(cmdArgs[3]);
						local lenPlayers = tonumber(cmdArgs[4]);
						local lenRaids = tonumber(cmdArgs[5]);
						
						-- msgFrom									
						
						if ((iDB == DKPMU_State.cur_db) and (DKPMU_State.cur_db_time == dbdate)) then
								table.insert(DKPMU_State.rx_client_playerdata, msgFrom);				
								DKPMU_State.txClientData[msgFrom] = {};
								DKPMU_State.txClientData[msgFrom]['players'] = lenPlayers;
								DKPMU_State.txClientData[msgFrom]['raids'] = lenRaids;
						end
																		
						--SendChatMessage("DB_START_BC:".. iDB ..":".. dbdate ..":".. msgFrom, "CHANNEL", nil, id);
				elseif ((cmdArgs[1] == "DB_END_BC") and DKPMU_State.rx) then
				-- ###############################
				-- Client Indicating they are done transmitting data
				-- ###############################					
				-- If a client we are listening to issues this command they are done their transmission and we can unserialize 
				-- their data.		
								
						local listenClient = false;
						for index, clientName in DKPMU_State.rx_client_playerdata do
								if (clientName == msgFrom) then
											listenClient = true;
								end
						end
						
						for index, clientName in DKPMU_State.rx_client_raiddata do
								if (clientName == msgFrom) then
											listenClient = true;
								end
						end	
						if (listenClient == false) then return; end											
								
						local switch = cmdArgs[2];
						
						if (switch == "P") then
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(BLUE .. "Player Data: Success Rec'd all data fr [".. msgFrom .."] size=".. strlen(DKPMU_State.rx_data[msgFrom])); end																
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "expected size = ".. DKPMU_State.txClientData[msgFrom]['players'] .." received size="..strlen(DKPMU_State.rx_data[msgFrom])); end
								
							
								--DKPM_Options[msgFrom]['player'] = DKPMU_State.rx_data[msgFrom];	
								local tmpDataArray = Sea.string.stringToObject(DKPMU_State.rx_data[msgFrom]);
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "Player Data: Parsing successful for [".. msgFrom .."]"); end
								--DKPM_Options[msgFrom]['player'] = "succcess";
								local count = 0;
								for playerName, playerData in tmpDataArray do			
										count = count +1;
										if (DKP_DB_TEMP[DKPMU_State.cur_db]['playerdata'] == nil) then 
												DKP_DB_TEMP[DKPMU_State.cur_db]['playerdata'] = {}; 
										end
										if (DKP_DB_TEMP[DKPMU_State.cur_db]['playerdata'][playerName] == nil) then
												DKP_DB_TEMP[DKPMU_State.cur_db]['playerdata'][playerName] = playerData;										
										else
												if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED.. "ERROR:".. YELLOW .. playerName .." already exists in DKP_DB_TEMP!!!"); end
										end
								end
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "Received Players fr ["..msgFrom.."] = "..count); end
								
								local remIndex = 0;
								for index, clientName in DKPMU_State.rx_client_playerdata do
										if (clientName == msgFrom) then 
												remIndex = index; 
												table.remove(DKPMU_State.rx_client_playerdata, remIndex);
										end
								end																									
								table.insert(DKPMU_State.rx_client_raiddata, msgFrom);			
								
								DKPMU_State.rx_data[msgFrom] = "";							
						elseif (switch == "R") then
								
								
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "expected size = ".. DKPMU_State.txClientData[msgFrom]['raids'] .." received size="..strlen(DKPMU_State.rx_data[msgFrom])); end
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(BLUE .. "Raid Data: Success Rec'd all data fr [".. msgFrom .."] size=".. strlen(DKPMU_State.rx_data[msgFrom])); end
								--DKPM_Options[msgFrom]['raid'] = DKPMU_State.rx_data[msgFrom];
								local tmpDataArray = Sea.string.stringToObject(DKPMU_State.rx_data[msgFrom]);
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "Raid Data: Parsing successful for [".. msgFrom .."]"); end
								--DKPM_Options[msgFrom]['raid'] = "succcess";
								
								count = 0;
								for raidName, raidData in tmpDataArray do	
										count = count +1;
										if (DKP_DB_TEMP[DKPMU_State.cur_db]['raiddata'] == nil) then 
												DKP_DB_TEMP[DKPMU_State.cur_db]['raiddata'] = {}; 
										end
										if (DKP_DB_TEMP[DKPMU_State.cur_db]['raiddata'][raidName] == nil) then
												DKP_DB_TEMP[DKPMU_State.cur_db]['raiddata'][raidName] = raidData;
										else
												if (debug) then DEFAULT_CHAT_FRAME:AddMessage(RED.. "ERROR:".. YELLOW .. raidName .." already exists in DKP_DB_TEMP!!!"); end
										end
								end
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(YELLOW .. "Received Raids fr ["..msgFrom.."] = "..count); end
								
								local remIndex = 0;
								for index, clientName in DKPMU_State.rx_client_raiddata do
										if (clientName == msgFrom) then 
												remIndex = index; 
												table.remove(DKPMU_State.rx_client_raiddata, remIndex);
										end
								end																
								DKPMU_State.rx_data[msgFrom] = "";								
						end	
						
						if (debug) then DEFAULT_CHAT_FRAME:AddMessage(" "); end
						
						if ((DKP_DB_TEMP[DKPMU_State.cur_db]['playerdata'] ~= nil) and (DKP_DB_TEMP[DKPMU_State.cur_db]['raiddata'] ~= nil)) then
																
								iPlayers = 0;			
								for playerName, playerData in DKP_DB_TEMP[DKPMU_State.cur_db]['playerdata'] do
										iPlayers = iPlayers + 1;
								end
											
								iRaids = 0;
								for raidID, raidData in DKP_DB_TEMP[DKPMU_State.cur_db]['raiddata'] do
										iRaids = iRaids + 1;
								end					
								
								if (debug) then DEFAULT_CHAT_FRAME:AddMessage(GREEN .."Transmission Recv'd fr ["..msgFrom.."] -- players:".. iPlayers .." raids:".. iRaids); end
								
								
								-- Update GUI and Database if all transmissions complete
								if ((DKPMU_State.players == iPlayers) and (DKPMU_State.raids == iRaids)) then
									
										if (debug) then DEFAULT_CHAT_FRAME:AddMessage(GREEN.. "DB Received successfuly, players + raids correct size"); end
										DKP_DB[DKPMU_State.cur_db] = DKP_DB_TEMP[DKPMU_State.cur_db];
										DKP_DB[DKPMU_State.cur_db]['chars'] = DKPMU_State.cur_db_size;
										DKP_DB_TEMP[DKPMU_State.cur_db] = nil;
										DKPMU_State.rx = false;										
										
										
										local est_time = (((DKPMU_State.cur_db_size)/255)*DKPM_TxInterval)/60;
										local est_time_min = format("%0.0f",math.floor(est_time));
										local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
										if (est_time <= 1) then
												est_time = est_time_sec .. " Sec";
										else 
												est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
										end 
										
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusRightText"):SetText(GREEN .. est_time);											
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."DBName"):SetText(GREEN.. DKP_DB[DKPMU_State.cur_db]['dbname']);
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."Users"):SetText(GREEN .. iPlayers);
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."Raids"):SetText(GREEN .. iRaids);
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."UpToDate"):SetText(GREEN .. "Yes");	
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."Status"):SetValue(0);
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusLeftText"):SetText(GREEN .. "Ready to Sync");	
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusRightText"):SetText(GREEN .. est_time);												
										
										DKPMU_FlushBroadcast();
										SendChatMessage("DB_REQ_ALL", "CHANNEL", nil, id);
										DKPMU_FlushRCClientsDB(DKPMU_State.cur_db); -- No more receviing clients
										if (debug) then DEFAULT_CHAT_FRAME:AddMessage(GREEN.. "Adding ourself to db"); end
										DKPMU_AddACClient(string.lower(UnitName("player")), DKPMU_State.cur_db); -- Add ourself to assisting clients
										if (debug) then DEFAULT_CHAT_FRAME:AddMessage(GREEN.. "Adding ourself to db successfull!"); end
										
										local i = DKPMU_State.cur_db;
										UIDropDownMenu_SetSelectedID(DKPM_CPOptionsDBDropDown, i);
										DKPM_Options.dbselect = i;
										
										DKP_ROLL_PLAYERS = DKP_DB[i]['playerdata'];
										DKP_ROLL_RAIDS = DKP_DB[i]['raiddata'];
										DKP_ROLL_UPDATE_INFO = DKP_DB[i]['updatedata'];
										
										DKPM_PlayerList_Update();
										DKPM_RaidHistoryList_Update();
										DKPM_IHItemList_Update();
								else
										if (debug) then DEFAULT_CHAT_FRAME:AddMessage("Transmissio not complete player=("..iPlayers.."/"..DKPMU_State.players..") raids=("..iRaids.."/"..DKPMU_State.raids..")"); end
								end								
						end								
				elseif (DKPMU_State.rx) then
						-- ###############################
						-- Receive Data From User
						-- ###############################							
						-- Receive data from users
						
						for index, clientName in DKPMU_State.rx_client_playerdata do
								if (clientName == msgFrom) then
										if (DKPMU_State.rx_data[msgFrom] == nil) then
												DKPMU_State.rx_data[msgFrom] = arg1;
										else
												DKPMU_State.rx_data[msgFrom] = DKPMU_State.rx_data[msgFrom] .. arg1; 
										end
										DKPMU_State.rx_chars = DKPMU_State.rx_chars + strlen(arg1);										
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."Status"):SetValue( (DKPMU_State.rx_chars/DKPMU_State.cur_db_size)*100 );

										local percent = format("%0.1f",(DKPMU_State.rx_chars/DKPMU_State.cur_db_size)*100);										
										--DEFAULT_CHAT_FRAME:AddMessage("percent = ".. percent);
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusLeftText"):SetText(GREEN .. "Receiving Data (".. percent .."%)");																														
								end
						end
							
						for index, clientName in DKPMU_State.rx_client_raiddata do
								if (clientName == msgFrom) then
										if (DKPMU_State.rx_data[msgFrom] == nil) then
												DKPMU_State.rx_data[msgFrom] = arg1;
										else
												DKPMU_State.rx_data[msgFrom] = DKPMU_State.rx_data[msgFrom] .. arg1; 
										end
										DKPMU_State.rx_chars = DKPMU_State.rx_chars + strlen(arg1);										
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."Status"):SetValue( (DKPMU_State.rx_chars/DKPMU_State.cur_db_size)*100 );
										
										local percent = format("%0.1f",(DKPMU_State.rx_chars/DKPMU_State.cur_db_size)*100);
										--DEFAULT_CHAT_FRAME:AddMessage("percent = ".. percent);
										getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusLeftText"):SetText(GREEN .. "Receiving Data (".. percent .."%)");									
								end
						end					
						
						--local est_time = ( ((size/255)*DKPM_TxInterval) / table.getn(DKPMU_State.aclients_list[iDB]) );
						--local est_time = est_time / 60;						
						local est_time = (((DKPMU_State.cur_db_size - DKPMU_State.rx_chars)/255)*DKPM_TxInterval) / table.getn(DKPMU_State.aclients_list[iDB]);
						local est_time = est_time / 60;
						local est_time_min = format("%0.0f",math.floor(est_time));
						local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
						if (est_time <= 1) then
								est_time = est_time_sec .. " Sec";
						else 
								est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
						end 
						getglobal("DKPM_CPSyncDBListRow"..DKPMU_State.cur_db.."StatusRightText"):SetText(GREEN .. est_time);									
				end																				
				
		end		

		--Pre_ChatFrame_OnEvent(event);
end

function DKPMU_AddACClient (clientName, iDB)
		-- Assisting Clients: Add user to client list for a database
		
		local exists = false;
		
		if (DKPMU_State.aclients_list[iDB] == nil) then DKPMU_State.aclients_list[iDB] = {}; end
		for index, client in DKPMU_State.aclients_list[iDB] do
				if (client == clientName) then exists = true; end										
		end																							
				
		if (not exists) then table.insert(DKPMU_State.aclients_list[iDB], clientName); end
		
		local size = 0;
		if ((DKPMU_State.rx) and (DKPMU_State.cur_db == iDB)) then
				size = DKPMU_State.cur_db_size;
		else
				size = DKP_DB[iDB]['chars'];
		end
						
		local est_time = ( ((size/255)*DKPM_TxInterval) / table.getn(DKPMU_State.aclients_list[iDB]) );
		local est_time = est_time / 60;
		local est_time_min = format("%0.0f",math.floor(est_time));
		local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
		if (est_time <= 1) then
				est_time = est_time_sec .. " Sec";
		else 
				est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
		end 
		
		getglobal("DKPM_CPSyncDBListRow"..iDB.."AC"):SetText(GREEN .. table.getn(DKPMU_State.aclients_list[iDB]));								
		getglobal("DKPM_CPSyncDBListRow"..iDB.."Status"):SetValue(0);
		getglobal("DKPM_CPSyncDBListRow"..iDB.."StatusLeftText"):SetText(GREEN .. "Ready to Sync");	
		getglobal("DKPM_CPSyncDBListRow"..iDB.."StatusRightText"):SetText(GREEN .. est_time);		
		
end

function DKPMU_RemoveACClient (clientName, iDB)
		-- Assisting Clients: Remove user from client list for a database
		
		local remIndex = 0;
		local exists = false;
		
		if (DKPMU_State.aclients_list[iDB] == nil) then DKPMU_State.aclients_list[iDB] = {}; end
		for index, client in DKPMU_State.aclients_list[iDB] do
				if (client == clientName) then 
						remIndex = index; 
						table.remove(DKPMU_State.aclients_list[iDB], remIndex);
				end					
		end							
															
		local size = 0;
		if ((DKPMU_State.rx) and (DKPMU_State.cur_db == iDB)) then
				size = DKPMU_State.cur_db_size;
		else
				if ((DKP_DB[iDB] ~= nil) and (DKP_DB[iDB]['chars'] ~= nil)) then
						size = DKP_DB[iDB]['chars'];
				else
						size = 0;
				end
		end
				
		local est_time = ( ((size/255)*DKPM_TxInterval) / table.getn(DKPMU_State.aclients_list[iDB]) );
		local est_time = est_time / 60;
		local est_time_min = format("%0.0f",math.floor(est_time));
		local est_time_sec = format("%0.0f",(est_time-math.floor(est_time))*60);																				
		if (est_time <= 1) then
				est_time = est_time_sec .. " Sec";
		else 
				est_time = est_time_min .." Min, ".. est_time_sec .. " Sec";
		end 
		
		getglobal("DKPM_CPSyncDBListRow"..iDB.."AC"):SetText(GREEN .. table.getn(DKPMU_State.aclients_list[iDB]));								
		getglobal("DKPM_CPSyncDBListRow"..iDB.."Status"):SetValue(0);
		getglobal("DKPM_CPSyncDBListRow"..iDB.."StatusLeftText"):SetText(GREEN .. "Ready to Sync");	
		getglobal("DKPM_CPSyncDBListRow"..iDB.."StatusRightText"):SetText(GREEN .. est_time);		
end

function DKPMU_FlushACClients() 
		for iDB = 0, 4 do
				if (DKP_DB[iDB] ~= nil) then
						DKPMU_State.aclients_list[iDB] = {};
						getglobal("DKPM_CPSyncDBListRow"..iDB.."AC"):SetText(GREEN .. table.getn(DKPMU_State.aclients_list[iDB]));
				end
		end
end

function DKPMU_FlushACClientsDB(iDB) 

		if (DKP_DB[iDB] ~= nil) then
				DKPMU_State.aclients_list[iDB] = {};
				getglobal("DKPM_CPSyncDBListRow"..iDB.."AC"):SetText(GREEN .. table.getn(DKPMU_State.aclients_list[iDB]));
		end

end

function DKPMU_AddRCClient (clientName, iDB)
		-- Recieving Clients: Add user to client list for a database
		
		local exists = false;
		
		if (DKPMU_State.rclients_list[iDB] == nil) then DKPMU_State.rclients_list[iDB] = {}; end
		for index, client in DKPMU_State.rclients_list[iDB] do
				if (client == clientName) then exists = true; end										
		end																							
				
		if (not exists) then table.insert(DKPMU_State.rclients_list[iDB], clientName); end
								
		getglobal("DKPM_CPSyncDBListRow"..iDB.."RC"):SetText(GREEN .. table.getn(DKPMU_State.rclients_list[iDB]));										
		
end

function DKPMU_RemoveRCClient (clientName, iDB)
		-- Recieving Clients: Remove user to client list for a database
		
		local remIndex = 0;
		local exists = false;
		
		if (DKPMU_State.rclients_list[iDB] == nil) then DKPMU_State.rclients_list[iDB] = {}; end
		for index, client in DKPMU_State.rclients_list[iDB] do
				if (client == clientName) then 
						remIndex = index; 
						table.remove(DKPMU_State.rclients_list[iDB], remIndex);
				end					
		end																							
		getglobal("DKPM_CPSyncDBListRow"..iDB.."RC"):SetText(GREEN .. table.getn(DKPMU_State.rclients_list[iDB]));
end

function DKPMU_FlushRCClients() 
		for iDB = 0, 4 do
				if (DKP_DB[iDB] ~= nil) then
						DKPMU_State.rclients_list[iDB] = {};
						getglobal("DKPM_CPSyncDBListRow"..iDB.."RC"):SetText(GREEN .. table.getn(DKPMU_State.rclients_list[iDB]));
				end
		end
end

function DKPMU_FlushRCClientsDB(iDB) 

		if (DKP_DB[iDB] ~= nil) then
				DKPMU_State.rclients_list[iDB] = {};
				getglobal("DKPM_CPSyncDBListRow"..iDB.."RC"):SetText(GREEN .. table.getn(DKPMU_State.rclients_list[iDB]));
		end

end

function DKPMU_FlushBroadcast() 
		for iDB = 0, table.getn(DKP_DB) do
				DKPMU_DbBroadcast[iDB] = false;
		end
end

function DKPM_PROTO_DB_VER (iDB)

		if ((DKP_DB[iDB] == nil) or (DKP_DB[iDB]['playerdata'] == nil) or (DKP_DB[iDB]['raiddata'] == nil)) then return; end

		id, name = GetChannelName(DKPMU_Options.channel);	

		iPlayers = 0;
		--SendChatMessage("CH:".. iDB, "CHANNEL", nil, id);
		for playerName, playerData in DKP_DB[iDB]['playerdata'] do
				iPlayers = iPlayers + 1;
		end
		
		iRaids = 0;
		--SendChatMessage("CH:".. iDB, "CHANNEL", nil, id);
		for raidID, raidData in DKP_DB[iDB]['raiddata'] do
				iRaids = iRaids + 1;
		end								
		
		SendChatMessage("DB_VER:".. iDB ..":".. DKP_DB[iDB]['dbname'] ..":".. DKP_DB[iDB]['dbdate'] ..":".. iPlayers ..":".. iRaids ..":".. DKP_DB[iDB]['chars'], "CHANNEL", nil, id);							
		
		DKPMU_State.mainclient = true; -- we are the main client since we were first to respond to the request
		DKPMU_State.ourclient = 1;  -- we are first client
		DKPMU_State.clients = 1;  -- we are so far only client		
		
		DKPMU_State.players = iPlayers;
		DKPMU_State.raids = iRaids;			
		DKPMU_State.cur_db = iDB;	

end

function DKPM_CPSyncToggle ()
			--DEFAULT_CHAT_FRAME:AddMessage("DKP_Matrix: Search Interface Toggled");
			if( not DKPM_CPSyncFrame:IsVisible() )then
					DKPM_CPSyncFrame:Show();
			else
					DKPM_CPSyncFrame:Hide();
			end
end


function DKPMU_SyncChannel_Update()
		
		local channel = string.lower(getglobal("DKPM_CPSyncChannelTextBox"):GetText());
		channel = string.gsub(channel, "[^a-zA-Z0-9]", "")
		channel = string.gsub(channel, " ", "")		
		getglobal("DKPM_CPSyncChannelTextBox"):SetText(channel);
		
		if ((DKPMU_Options.channel ~= channel) and (channel ~= "")) then
				LeaveChannelByName(DKPMU_Options.channel);
								
				DKPMU_Options.channel = channel;

				local zoneChannel, channelName = JoinChannelByName(channel, nil, DEFAULT_CHAT_FRAME:GetID());	
				if (debug) then ChatFrame_AddChannel(DEFAULT_CHAT_FRAME, channel); end
				--AddChatWindowChannel(DEFAULT_CHAT_FRAME:GetID(), channelName);
				--DEFAULT_CHAT_FRAME:AddMessage("ch:"..zoneChannel);
								
				DKPMU_FlushBroadcast();
	
		end		
end

function DKPMU_CPSyncDSetActiveSync_OnClick()
	local checked = getglobal("DKPM_CPAutoSyncEnableCheckBox"):GetChecked();		

	if (checked == 1) then			
			DKPM_CPAutoSyncNowButton:Disable();
			DKPMU_Options.autosync = true;
	else
			DKPM_CPAutoSyncNowButton:Enable();
			DKPMU_Options.autosync = false;
	end	

end

function DKPMU_CPSyncEnableCheckBox_OnClick()

	local checked = getglobal("DKPM_CPSyncEnableCheckBox"):GetChecked();		
	
	if (checked == 1) then
			DKPMU_Options.active = true;
	else
			DKPMU_Options.active = false;
	end
--DKPMU_Options.active

end