--=============================================================================
-- File:		localization.en.lua
-- Author:	(synd][cate) 
--          Sammysnake of Ner'Zhul	 2004, 2005 Syndicate Systems
--
-- Description:	EN localization File
--
-- Created: July, 17, 2005
-- Modified: Feb, 26, 2006
--=============================================================================

-- Declard color codes for console messages
local RED     = "|cffff0000";
local GREEN   = "|cff00ff00";
local BLUE    = "|cff0000ff";
local MAGENTA = "|cffff00ff";
local YELLOW  = "|cffffff00";
local CYAN    = "|cff00ffff";
local WHITE   = "|cffffffff";

				
		--=============================================================================
		-- Class Strings
		--=============================================================================
		
		DKPM_Class = {
				warlock 	= "warlock",
				warrior		= "warrior",
				shaman		= "shaman",
				mage			=	"mage",
				hunter		= "hunter",
				priest		= "priest",
				paladin		= "paladin",
				rogue			= "rogue",
				druid			=	"druid",
				cloth			=	"cloth",
				leather		= "leather",
				mail			=	"mail",
				plate			= "plate"		}
				
		
		--=============================================================================
		-- General Strings
		--=============================================================================
		
		
		DKPM_MSG_GUI_TOGGLED = RED .. "DKP_System: ".. WHITE .."Interface Toggled.";
		
		DKPM_MESSAGE_DKP_FIRSTRUN = RED .. "DKP_System:".. WHITE .." First time run detected, adding new configuration settings!";
		DKPM_MESSAGE_DKP_PREVINST = RED .. "DKP_System:".. WHITE .." Config data detected from older version of dkp_roll, adjusting new config settings.";
		
		
		DKPM_MESSAGE_DKP_LOADED1 = RED .. "DKP_System: ".. WHITE .." Loaded. ".. GREEN.. "(Ver %s)".. WHITE .." Coded by Sammysnake (".. WHITE .. "synd".. RED .. "][".. WHITE .."cate)";
		DKPM_MESSAGE_DKP_LOADED2 = RED .. "DKP_System: ".. WHITE .." For help type, /roll help, /auction help";
		
		--=============================================================================
		-- Error Strings
		--=============================================================================
		
		DKPM_ERROR_PLAYER_NOT_FOUND 	= "Player [%s] could not be found in the database.";
		DKPM_ERROR_PLAYER_DENIED_BID = "Sorry %s, only users in the DKP database can bid.";
		DKPM_ERROR_PLAYER_DENIED_BOT = "Access Denied! Sorry, only users in the DKP database have access to bot commands";
		DKPM_ERROR_USAGE						 	= "Error- Command not recognized.";
		DKPM_ERROR_HELP_USAGE			 	= "Error- No help information exists for that command, please make sure you typed it correctly!";
		
		DKPM_ERROR_SQLVARS_ERROR1		= RED .. "DKP_System:".. WHITE .." ERROR- sqlvars.lua does not exist, please";
		DKPM_ERROR_SQLVARS_ERROR2		= RED .. "DKP_System:".. WHITE .." ERROR- run DKP_System Updater first.  Type";
		DKPM_ERROR_SQLVARS_ERROR3		= RED .. "DKP_System:".. WHITE .." ERROR- /console reloadui after you have";
		DKPM_ERROR_SQLVARS_ERROR4		= RED .. "DKP_System:".. WHITE .." ERROR- ran the updater and updated the variables.";
		
		DKPM_ERROR_VER_ERROR1				= RED .. "DKP_System:".. WHITE .." ERROR- Version mismatch, please dkp_roll, dkp_roll updater, and process_dkp.php are up to date!";
		DKPM_ERROR_VER_ERROR2				= RED .. "DKP_System:".. WHITE .." ERROR- DKP_Roll Version: %s";
		DKPM_ERROR_VER_ERROR3				= RED .. "DKP_System:".. WHITE .." ERROR- Process_dkp.php Version: %s";
		
		DKPM_ERROR_UNKNOWN						= RED .. "DKP_System:".. WHITE .." ERROR- Unknown Error!!";
		
		DKPM_WARNING_ROLL1						= RED .. "DKP_System:".. WHITE .." WARNING: Roll detected, however bidding system set to %s auction.";
		DKPM_WARNING_ROLL2						= RED .. "DKP_System:".. WHITE .." Type '/roll set' to enable auctioned rolling!";
		DKPM_WARNING_ROLL3						= RED .. "DKP_System:".. WHITE .." This warning will be disabled for future rolls.";
		
		-- ## General Usage
		
		DKPM_GENERAL_COMMAND_USAGE_LINE1 = GREEN .. "Usage:" .. WHITE .."  /roll (on | off | announce | group | raid | guild | say)";
		DKPM_GENERAL_COMMAND_USAGE_LINE2 = GREEN .. "Usage:" .. WHITE .."  /roll set - Set Auction system use ROLL";
		DKPM_GENERAL_COMMAND_USAGE_LINE3 = GREEN .. "Usage:" .. WHITE .."  /roll bot (on | off) - Enable/Disable BOT commands";
		DKPM_GENERAL_COMMAND_USAGE_LINE4 = GREEN .. "Usage:" .. WHITE .."  /roll bot (showtell | hidetell) - Enable/Disable bot responses are echoed";
		DKPM_GENERAL_COMMAND_USAGE_LINE5 = GREEN .. "Usage:" .. WHITE .."  /roll mod {number} - Change point modifier (Default=2)";
		
		
		--=============================================================================
		-- Auction Strings
		--=============================================================================
		
		DKPM_AUCTION_DROPDOWN_LIST = {
				{name="Open Auction", value="OPEN", shortname="Open"},
				{name="Closed Auction", value="CLOSED", shortname="Closed"},
				{name="Roll Auction", value="ROLL", shortname="Roll"}
		};		
		
		DKPM_AUCTION_TYPES 	= {
				CLOSED 	= "CLOSED",
				OPEN 		= "OPEN",
				ROLL 		= "ROLL",
		}
		
		DKPM_AUCTION_DISPLAY_BIDS					= RED .. "DKP_System:".. WHITE .." Display current bids..";
		DKPM_AUCTION_CHANNEL							= RED .. "DKP_System:".. WHITE .. "Open Auction, listening to channel [%s]";
		DKPM_AUCTION_CHANNEL_SET					= RED .. "DKP_System:".. WHITE .. "Channel set to [%s]";
		
		-- ## Auction Usage
		DKPM_AUCTION_COMMAND_USAGE_LINE1 = GREEN .. "Usage:" .. WHITE .."  /auc (open | closed) - Sets auction mode to OPEN or CLOSED.";
		
		-- ## Errors/Warnings/Notifications
		DKPM_AUCTION_WISP_INSUFFICENT_DKP1 	= "You don't have enough DKP to wager that bid!";
		DKPM_AUCTION_WISP_BID_DROPPED			 	= "Orginal bid of %s DKP dropped.";
		DKPM_AUCTION_WISP_BID_ACCEPTED		 	= "Bid ACCEPTED for %s DKP!";
		DKPM_AUCTION_TYPE										= RED .. "DKP_System:".. WHITE .." Bidding system set to %s";
		DKPM_AUCTION_STARTED								= RED .. "DKP_System:".. WHITE .." Auction started.";
		DKPM_AUCTION_ENDED									= RED .. "DKP_System:".. WHITE .." Auction ended.";
		
		-- ## ROLL:Auction Usage
		DKPM_AUCTION_POINT_MOD						 = RED .. "DKP_System:".. WHITE .." RaidPoint modifier set to %s.";
		
		-- ## OPEN:Auction Usage
		DKPM_AUCTION_USAGE_SETCH					= RED .. "DKP_System:".. WHITE .." use /auc ch <channel> to set auction channel, and ensure you have /join <channel>"
		DKPM_AUCTION_WISP_NO_AUCTION			= "There is no auction started yet!";
		DKPM_AUCTION_WISP_NOT_OPENMODE  	= "Not in 'open' auction mode!";
		DKPM_AUCTION_WISP_NOT_CLOSEDMODE	= "Not in 'closed' auction mode!";
		
		-- ## Slash Command Usage
		DKPM_SLASH_MSG_INVALID_ARGUMENTS	= RED .. "DKP_System:".. WHITE .." Invalid arguments..";
		DKPM_SLASH_MSG_ALREADY_ENABLED		= RED .. "DKP_System:".. WHITE .." Already Enabled!";
		DKPM_SLASH_MSG_ENABLED						=	RED .. "DKP_System:".. WHITE .." Enabled!";
		DKPM_SLASH_MSG_DISABLED						= RED .. "DKP_System:".. WHITE .." Already Disabled!";
		DKPM_SLASH_MSG_ANNOUNCE_DISABLED	= RED .. "DKP_System:".. WHITE .." Announce Disabled!";
		DKPM_SLASH_MSG_ANNOUNCE_ENABLED		= RED .. "DKP_System:".. WHITE .." Announce Enabled ( /%s )!";
		DKPM_SLASH_MSG_ANNOUNCE_TYPE			= RED .. "DKP_System:".. WHITE .." Announce set to /%s!";
		
		
		--=============================================================================
		-- Bot Strings
		--=============================================================================
		
		-- ## BOT:User
		
		DKPM_BOT_ACCESSDENIED						= "Access Denied! Sorry, only users in the DKP database have access to bot commands!";
		DKPM_BOT_DISABLED								= "DKP_Matrix bot is currently disabled!";
		DKPM_BOT_NOAVAILDB							= "ERROR! There is currently no databases available!";
		
		DKPM_BOT_NEWUSER1								= "(New User) Search mode set to 'all', type '%s searchmode (all / any)' to change.";
		DKPM_BOT_NEWUSER2								= "(New User) Search threshold set to 0, type '%s searchth {number}' to change.";
		DKPM_BOT_NEWUSER3								= "(New User) Search results set to 10, type '%s results {number}' to change.";
		DKPM_BOT_NEWUSER4								= "(New User) Default database 0 selected, if your guild runs multiple databases type '%s listdb' to change.";
		DKPM_BOT_NEWUSER5								= "For bot commands type '%s help', and for more info on each command '%s help <command>' ";
		DKPM_BOT_NEWUSER6								= "Also highly recommended you resize your chat window horizontally so lines do no word-wrap!";
		
		
		DKPM_BOT_USERDKP							= "(Currently you have %s DKP)";
		DKPM_BOT_USERDKP_DETAILED				= "You have %s DKP, spent %s DKP, and gained %s overall.";
		DKPM_BOT_USERSDKP_DETAILED			= "%s currently has %s DKP, spent %s DKP and gained %s overall.";
		
		DKPM_BOT_LAST_DB_UPDATE					= "[Updated with website last @ %s]";
		
		DKPM_BOT_SEARCH_MODE						= "Search mode set to matching %s keywords!";
		DKPM_BOT_SEARCH_THRESHOLD				= "Search threshold set to great or equal to %s";
		DKPM_BOT_SEARCH_RESULTS					= "Search results to return set to %s";
		
		-- ## BOT:Queries
		
		DKPM_BOT_ITEM_NOHISTORY				  = "Could not find a player history for %s";
		DKPM_BOT_ITEM_HISTORY						= "Displaying Item History for %s";
		DKPM_BOT_ITEM_DKPSPENT					= "%s DKP Spent Total!";
		
		DKPM_BOT_QUERY_TOPDKP_FOR		 		= "Top %s DKP Listing for %s";
		DKPM_BOT_QUERY_TOPDKP_OVERALL		= "Top %s DKP Listing Overall";
		
		DKPM_BOT_QUERY_DKP							= "#%s] %s with %s DKP. [#%s overall]";
		DKPM_BOT_QUERY_DKP_CLASS				= "#%s [%s] %s with %s DKP."
		
		-- ## BOT:Usage
		DKPM_BOT_COMMAND_USAGE_LINE1		= "'%s help <command>' - Displays detailed help for a specific command";
		DKPM_BOT_COMMAND_USAGE_LINE2		= "<< Commands >>";
		DKPM_BOT_COMMAND_USAGE_LINE3    = "%s, %s <playername>";
		DKPM_BOT_COMMAND_USAGE_LINE4		= "%s top, %s top <class>, %s top (cloth / leather / mail / plate)";
		DKPM_BOT_COMMAND_USAGE_LINE5		= "%s items, %s items <playername>"
		DKPM_BOT_COMMAND_USAGE_LINE6		= "%s search <keywords>";
		DKPM_BOT_COMMAND_USAGE_LINE7		= "%s graids, %s raidinfo <raid id>";
		DKPM_BOT_COMMAND_USAGE_LINE8		= "%s raids, %s raids <playername>";
		DKPM_BOT_COMMAND_USAGE_LINE9		= "%s listdb, %s selectdb <db id>";
		
		-- ## BOT:Fatal Errors
		
		DKPM_BOT_FATALERR_CANNOTINI = "Error! Unable to initialize default database since there is no database in slot 0!";
		
		-- ## BOT:General Errors
		
		DKPM_BOT_ERR_INVALIDBSELECT1 = "Invalid database selection, Database(s) Available:";
		DKPM_BOT_ERR_INVALIDBSELECT2 = "Type '%s selectdb <db id>' to select a database!";
						
				
		-- ## BOT:Type Mismatch
		
		DKPM_BOT_ERR_MISMATCH_RAIDINFO	= "Syntax Error: Format is '%s raidinfo {raid id}'";		
				
		
		-- ## BOT:Help
		
		-- rp help rp
		DKPM_BOT_HELP_RP_USAGE_LINE1		= "'%s' - Gives you your own DKP";
		DKPM_BOT_HELP_RP_USAGE_LINE2		= "'%s <player name>' Get someone elses DKP";
		
		-- rp help top
		DKPM_BOT_HELP_TOP_USAGE_LINE1		= "'%s top' Displays top players with highest DKP";
		DKPM_BOT_HELP_TOP_USAGE_LINE2		= "'%s top <class>' Display top players highest DKP in a specific class";
		
		-- rp help items
		DKPM_BOT_HELP_ITEMS_USAGE_LINE1 	= "'%s items' Displays your own item history";
		DKPM_BOT_HELP_ITEMS_USAGE_LINE2	= "'%s items <player name>' Displays someone elses item history";
		
		-- rp help search
		DKPM_BOT_HELP_SEARCH_USAGE_LINE1 = "'%s search <keywords>' Item search using supplied keywords";
		DKPM_BOT_HELP_SEARCH_USAGE_LINE2 = "'%s searchmode (all / any) ' Sets search mode to match all words / any of the words (type '%s help searchmode' to info on difference between all/any)";
		DKPM_BOT_HELP_SEARCH_USAGE_LINE3 = "'%s searchth {number} ' Sets search DKP threshold greater or equal to {number}";
		
		-- rp help searchmode
		DKPM_BOT_HELP_SEARCHMODE_USAGE_LINE1 = "'%s searchmode (all / any) ' Sets search mode to match all words / any of the words";
		DKPM_BOT_HELP_SEARCHMODE_USAGE_LINE2 = "eg. all - you search for nemesis bracers, returns items that have both nemesis and bracers in the name";
		DKPM_BOT_HELP_SEARCHMODE_USAGE_LINE3 = "eg. any - you search for nemesis bracers, returns items that have either the word nemesis or bracers in them";
		
		-- rp help searchth
		DKPM_BOT_HELP_SEARCHTH_USAGE_LINE1 = "'%s searchth {number} ' - Sets search DKP threshold greater or equal to {number}";
		DKPM_BOT_HELP_SEARCHTH_USAGE_LINE2 = "eg. You don't want to see crappy 5dkp items, set it to 10";
		
		-- rp help graids
		DKPM_BOT_HELP_GRAIDS_USAGE_LINE1	= "'%s graids' Displays the latest guild events";
		DKPM_BOT_HELP_GRAIDS_USAGE_LINE2	= "A raid ID is listed beside each raid, '$s raidinfo <raid id>' will give you more information about that raid";
		
		-- rp help raidinfo
		DKPM_BOT_HELP_RAIDINFO_USAGE_LINE1	= "'%s raidinfo <raid id>' Displays items dropped by a certain boss and class statistics for that event";
		DKPM_BOT_HELP_RAIDINFO_USAGE_LINE2	= "The <raidid> can be found from the command '%s graids'";
		
		-- rp help raids
		DKPM_BOT_HELP_RAIDS_USAGE_LINE1	= "'%s raids' Displays last raid events you have attended";
		DKPM_BOT_HELP_RAIDS_USAGE_LINE2	= "Use '%s raids <player name>' to display someone elses raid attendance";
		
		-- rp help listdb
		DKPM_BOT_HELP_LISTDB_USAGE_LINE1	= "'%s listdb' Displays available databases that can be selected";
		DKPM_BOT_HELP_LISTDB_USAGE_LINE2	= "This allows you to query seperate databases for ZG,MC,BWL,etc.";		

		-- rp help listdb
		DKPM_BOT_HELP_SELECTDB_USAGE_LINE1	= "'%s selectdb <db id>' Selects a database depending on db id, the database id's are listed using the '%s listdb' command.";
		
